package de.tud.kom.p2psim.impl.application.KBRApplication.messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.overlay.OverlayKey;

/**
 * This message is used to announce new documents in an KBR overlay. The overlay routes this message
 * to the node that is responsible for the key of the file.
 * 
 * @author Julius Rueckert
 *
 */
public class AnnounceNewDocumentMessage implements Message {

	private OverlayContact senderContact;
	
	private OverlayKey documentKey;
	
	/**
	 * @param senderContact the initiator of the announcement 
	 * @param documentKey the key of the new file
	 */
	public AnnounceNewDocumentMessage(OverlayContact senderContact, OverlayKey documentKey) {
		this.senderContact = senderContact;
		this.documentKey = documentKey;
	}
	
	/**
	 * @return the initiator of the announcement
	 */
	public OverlayContact getSenderContact(){
		return senderContact;
	}
	
	/**
	 * @return the key of the new document
	 */
	public OverlayKey getDocumentKey(){
		return documentKey;
	}
	
	@Override
	public Message getPayload() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public long getSize() {
		return MessageConfig.Sizes.AnnounceNewDocumentMessage;
	}

}
