package de.tud.kom.p2psim.impl.application.KBRApplication.messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.overlay.OverlayKey;

/**
 * This message is used to query for a document.
 * 
 * @author Julius Rueckert
 *
 */
public class QueryForDocumentMessage implements Message {

	private OverlayKey key;
	
	private OverlayContact senderContact;
	
	/**
	 * @param senderContact the contact of the node that initiated the query
	 * @param key the key to query for
	 */
	public QueryForDocumentMessage(OverlayContact senderContact, OverlayKey key){
		this.senderContact = senderContact;
		this.key = key;
	}
	
	/**
	 * @return the key to query for
	 */
	public OverlayKey getKey(){
		return key;
	}
	
	/**
	 * @return the contact of the node that initiated the query
	 */
	public OverlayContact getSenderContact(){
		return senderContact;
	}
	
	@Override
	public Message getPayload() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public long getSize() {
		return MessageConfig.Sizes.QueryForDocumentMessage;
	}

}
