package de.tud.kom.p2psim.impl.application.KBRApplication.messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.overlay.OverlayKey;

/**
 * This message is used to answer to a query for a document.
 * 
 * @author Julius Rueckert
 *
 */
public class QueryResultMessage implements Message {

	private OverlayContact senderContact;
	private OverlayKey key;
	private OverlayContact documentProvider;
	
	/**
	 * @param senderContact the contact of the node that initiated the answer to the query
	 * @param key the key that was queried for
	 * @param documentProvider the contact of the node that provides the document queried for
	 */
	public QueryResultMessage(OverlayContact senderContact, OverlayKey key, OverlayContact documentProvider){
		this.senderContact = senderContact;
		this.key = key;
		this.documentProvider = documentProvider;
	}
	
	/**
	 * @return the contact of the node that initiated the answer to the query
	 */
	public OverlayContact getSenderContact() {
		return senderContact;
	}
	
	/**
	 * @return the key that was queried for
	 */
	public OverlayKey getKey() {
		return key;
	}
	
	/**
	 * @return the contact of the node that provides the file queried for
	 */
	public OverlayContact getDocumentProvider() {
		return documentProvider;
	}
	
	@Override
	public Message getPayload() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public long getSize() {
		return MessageConfig.Sizes.QueryResultMessage;
	}

}
