package de.tud.kom.p2psim.impl.application.KBRApplication.messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.overlay.OverlayKey;

/**
 * This message is used to request a document.
 * 
 * @author Julius Rueckert
 *
 */
public class RequestDocumentMessage implements Message {

	private OverlayContact senderContact;
	private OverlayKey keyOfDocument;
	
	/**
	 * @param keyOfDocument the key of the file that is requested
	 * @param senderContact the contact of the node that initiated the request
	 */
	public RequestDocumentMessage(OverlayKey keyOfDocument, OverlayContact senderContact){
		
		this.senderContact = senderContact;
		this.keyOfDocument = keyOfDocument;
	}
	
	@Override
	public Message getPayload() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public long getSize() {
		return MessageConfig.Sizes.RequestDocumentMessage;
	}

	/**
	 * @return the contact of the node that initiated the request
	 */
	public OverlayContact getSenderContact() {
		return senderContact;
	}

	/**
	 * @return the key of the file that is requested
	 */
	public OverlayKey getKeyOfDocument() {
		return keyOfDocument;
	}

}
