package de.tud.kom.p2psim.impl.application.KBRApplication.messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.overlay.OverlayKey;
import de.tud.kom.p2psim.api.storage.Document;

/**
 * This message is used to send a document.
 * 
 * @author Julius Rueckert
 *
 */
public class TransferDocumentMessage implements Message {

	private OverlayContact senderContact;
	private OverlayKey keyOfDocument;
	private Document doc;
	
	/**
	 * @param keyOfDocument the key of the document transfered within this message
	 * @param senderContact the contact oft the node that sends the document
	 * @param doc the document that is sent
	 */
	public TransferDocumentMessage(OverlayKey keyOfDocument, OverlayContact senderContact, Document doc){
		
		this.senderContact = senderContact;
		this.keyOfDocument = keyOfDocument;
		this.doc = doc;
	}
	
	@Override
	public Message getPayload() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public long getSize() {
		return doc.getSize()+MessageConfig.Sizes.TransferDocumentMessage;
	}

	/**
	 * @return the contact oft the node that sends the document
	 */
	public OverlayContact getSenderContact() {
		return senderContact;
	}

	/**
	 * @return the key of the document transfered within this message
	 */
	public OverlayKey getKeyOfDocument() {
		return keyOfDocument;
	}

}
