package de.tud.kom.p2psim.impl.application.KBRApplication.operations;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.overlay.KBR;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.impl.application.KBRApplication.KBRDocument;
import de.tud.kom.p2psim.impl.application.KBRApplication.KBRDummyApplication;
import de.tud.kom.p2psim.impl.application.KBRApplication.messages.AnnounceNewDocumentMessage;
import de.tud.kom.p2psim.impl.common.AbstractOperation;

/**
 * This operation is used to announce new documents.
 * 
 * @author Julius Rueckert
 *
 */
public class AnnounceNewDocumentOperation extends AbstractOperation {

	private KBRDocument doc;
	private OverlayContact ownerContact;
	private KBR node;
	
	/**
	 * @param app the application that created the operation
	 * @param doc the document to announce
	 * @param callback 
	 */
	public AnnounceNewDocumentOperation(KBRDummyApplication app, KBRDocument doc, OperationCallback callback){
		super(app, callback);
		
		this.doc = doc;
		this.ownerContact = app.getNode().getLocalOverlayContact();
		this.node = app.getNode();
	}
	
	@Override
	protected void execute() {
		getComponent().getHost().getStorage().storeDocument(doc);
		
		Message announceMsg = new AnnounceNewDocumentMessage(ownerContact, doc.getKey());
		node.route(doc.getKey(), announceMsg, null);
		
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		// TODO Auto-generated method stub
		return null;
	}

}
