package de.tud.kom.p2psim.impl.application.KBRApplication.operations;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.overlay.OverlayKey;
import de.tud.kom.p2psim.impl.application.KBRApplication.KBRDummyApplication;
import de.tud.kom.p2psim.impl.application.KBRApplication.messages.QueryForDocumentMessage;
import de.tud.kom.p2psim.impl.common.AbstractOperation;

/**
 * This operation is used to query for documents.
 * 
 * @author Julius Rueckert
 *
 */
public class QueryForDocumentOperation extends AbstractOperation {

	private OverlayKey key;
	private KBRDummyApplication app;
	private OverlayContact senderContact;
	
	/**
	 * @param app the application that created the operation
	 * @param key the key of the document to query for
	 * @param callback 
	 */
	public QueryForDocumentOperation(KBRDummyApplication app, OverlayKey key, OperationCallback callback){
		super(app, callback);
		
		this.key = key;
		this.app = app;
		this.senderContact = app.getNode().getLocalOverlayContact();
	}
	
	@Override
	protected void execute() {
		
		Message msg = new QueryForDocumentMessage(senderContact, key);
		app.getNode().route(key, msg, null);

		operationFinished(true);
	}

	@Override
	public Object getResult() {
		// TODO Auto-generated method stub
		return null;
	}

}
