package de.tud.kom.p2psim.impl.network.gnp.geoip;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Iterator;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.Map.Entry;

public class IspLookupService {

	SortedMap<Long, String> data;

	public IspLookupService(String path) {
		data = new TreeMap<Long, String>();
		try {
			readFile(path);
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	private void readFile(String path) throws IOException {
		FileReader fr = new FileReader(path);
		BufferedReader in = new BufferedReader(fr);
		String line = null;
		while ((line = in.readLine()) != null) {
			String[] tmp = line.split(",");
			data.put(Long.valueOf(tmp[0]), tmp[2].replace("\"", ""));
			data.put(Long.valueOf(tmp[1]), tmp[2].replace("\"", ""));
		}
	}

	public String getISP(long ip) {
		Iterator<Entry<Long, String>> it = data.entrySet().iterator();
		while (it.hasNext()) {
			Entry<Long, String> lowerBound = it.next();
			if (ip >= lowerBound.getKey()) {
				if (it.hasNext()) {
					Entry<Long, String> upperBound = it.next();
					if (ip <= upperBound.getKey() && upperBound.getValue().equals(lowerBound.getValue()))
						return lowerBound.getValue();
				}
			}
		}
		return null;
	}
}
