package de.tud.kom.p2psim.impl.network.gnp.topology;

/**
 * Interface for geolocation services
 * 
 * @author Gerald Klunker
 * @version 0.1, 09.01.2008
 * 
 */
public interface Geolocator {

	/**
	 * 
	 * @param IP-address
	 *            in a readable form like "130.83.47.128"
	 * @return true, if IP could be located
	 */
	public boolean search(String ip);

	/**
	 * 
	 * @param 32-bit
	 *            IP-address
	 * @return true, if IP could be located
	 */
	public boolean search(Long ip);

	/**
	 * 
	 * @return latitude of last search result, return nan, if ip could not be
	 *         located
	 */
	public double getLatitude();

	/**
	 * 
	 * @return longitude of last search result, return nan, if ip could not be
	 *         located
	 */
	public double getLongitude();

	/**
	 * 
	 * @return 2-digit country code of last search result, return null, if ip
	 *         could not be located
	 */
	public String getCountryCode();

	/**
	 * 
	 * @return country name of last search result , return null, if ip could not
	 *         be located
	 */
	public String getCountryName();
	

	/**
	 * 
	 * @return region name of last search result , return null, if ip could not
	 *         be located
	 */
	public String getRegionName();
	
	/**
	 * 
	 * @return city name of last search result , return null, if ip could not
	 *         be located
	 */
	public String getCityName();
	
	

}
