package de.tud.kom.p2psim.impl.overlay.dht.chord;

import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import de.tud.kom.p2psim.api.transport.TransInfo;

/**
 * @author Yue Sheng
 * @version 3.0, Apr 12, 2008
 * 
 */
public class ChordIDGenerator {
	/**
	 * @param transInfo
	 * @return bigInteger representation of a Chord ID
	 */
	public BigInteger getID(TransInfo transInfo) {
		return getID(transInfo.getNetId().toString());
	}

	/**
	 * @param s
	 *            The string to be hashed
	 * @return The bigInteger-representation of a Chord ID
	 */
	public BigInteger getID(String s) {
		MessageDigest md;
		byte[] sha1hash = new byte[20];
		try {
			md = MessageDigest.getInstance("SHA-1");
			md.update(s.getBytes("iso-8859-1"), 0, s.length());
			sha1hash = md.digest();
		} catch (NoSuchAlgorithmException e) {
			System.err.println("NoSuchAlgorithmException");
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			System.err.println("UnsupportedEncodingException");
			e.printStackTrace();
		}
		return new BigInteger(1,sha1hash);
	}
}
