package de.tud.kom.p2psim.impl.overlay.dht.chord;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.math.BigInteger;

import sun.security.util.BigInt;

import de.tud.kom.p2psim.api.overlay.OverlayID;
import de.tud.kom.p2psim.api.overlay.OverlayKey;

/**
 * @author Yue Sheng
 * @version 3.0, May 6, 2008
 */
public class ChordKey implements OverlayKey{

	private BigInteger id;
	
	/**
	 * @param v The value of the key
	 */
	public ChordKey(String v){
		id = new ChordIDGenerator().getID(v);
	}

	public ChordKey(BigInteger id){
		this.id = id;
	}
	
	public byte[] getBytes() {
		byte[] buf =null;
		try{
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
			ObjectOutput out = new ObjectOutputStream(bos);
			out.writeObject(this);
			out.close(); 
			
			buf=bos.toByteArray();
		} catch (IOException e) {
			System.err.println("IOException!");
		}
		return buf;
	}

	public Object getUniqueValue() {
		return id;
	}

	public int compareTo(OverlayKey o) {
		ChordKey another = (ChordKey) o;
		return this.id.compareTo(another.getKeyID());
	}
	
	public int compareTo(OverlayID o){
		return this.id.compareTo((BigInteger) o.getUniqueValue());
	}

	public BigInteger getKeyID(){
		return id;
	}
	
	public String toString(){
		return id.toString();
	}
}
