package de.tud.kom.p2psim.impl.overlay.dht.chord;

import de.tud.kom.p2psim.api.common.Component;
import de.tud.kom.p2psim.api.common.ComponentFactory;
import de.tud.kom.p2psim.api.common.Host;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayNode.PeerStatus;

/**
 * This is the factory to create KBRChordNodes
 * 
 * @author Julius Rueckert
 *
 */
public class KBRChordNodeFactory implements ComponentFactory {

	private short port = 123;

	ChordBootstrapManager bootstrap = new ChordBootstrapManager();

	@Override
	public Component createComponent(Host host) {
		KBRChordNode node = new KBRChordNode(host.getTransLayer(), port);
		node.setBootstrap(bootstrap);
		node.setPeerStatus(PeerStatus.TO_JOIN);
		return node;
	}

	/**
	 * @param port
	 *            The port, which will be used by a new node
	 */
	public void setPort(int port) {
		this.port = (short) port;
	}
}
