package de.tud.kom.p2psim.impl.overlay.dht.chord;

import java.util.Random;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.overlay.dht.chord.operations.LookupOperation;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public class RandomLookupApplication extends ChordApplication{
	private int num;
	private String dataName;
	private boolean lookupIsRunning;
	private Random random;
	ChordKey k;
	SimpleDHTObject obj;
	
	public RandomLookupApplication(ChordNode n, int num, String dataName, Random r){
		super(n);
		this.num=num;
		this.dataName = dataName;
		this.random =r;
	}
	
	public void join(OperationCallback callback){
		getNode().join(callback);
	}
	
	public void leave(OperationCallback callback){
		getNode().leave(callback);
	}
	
	public void store(){
		for(int i=0;i<num;i++){
			String data = dataName+i;
			k = new ChordKey(data);
			obj = new SimpleDHTObject();
			obj.setKey(k);
			getNode().store(k, obj, this);
		}
	}
	
	public void randomLookup(){
		lookupIsRunning = true;
		String data = dataName+random.nextInt(num);
		k = new ChordKey(data);
		getNode().valueLookup(k, this);
	}
	
	public void stopLookup(){
		this.lookupIsRunning = false;
	}
	
	public void calledOperationFailed(Operation op) {
		calledOperationSucceeded(op);
	}

	public void calledOperationSucceeded(Operation op) {
		if (op instanceof LookupOperation) {
			LookupOperation lookup = (LookupOperation) op;
			if(lookup.forValue() && lookupIsRunning){
				String data = dataName+random.nextInt(num);
				k = new ChordKey(data);
				lookup = new LookupOperation(getNode(),k,this,true);
				lookup.scheduleWithDelay(Simulator.MINUTE_UNIT);
			}
		}
	}
}
