package de.tud.kom.p2psim.impl.overlay.dht.chord.messages;

import de.tud.kom.p2psim.api.overlay.OverlayKey;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordID;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordKey;

/**
 * this is a request to get some field of a node
 * 
 * @author Yue Sheng
 */
public class GetInfoRequest extends ChordMessage {

	private String fieldName = null;

	private OverlayKey key = null;

	private int cmdID=-2;
	/**
	 * @param sender
	 * @param receiver
	 * @param type
	 *            The type of request can be: "pre"(for predecessor), "succ"(for
	 *            successor list), "dhtObject"(for valueLookup)
	 */
	public GetInfoRequest(ChordID sender, ChordID receiver, String type) {
		super(sender, receiver);
		fieldName = type;
	}

	public GetInfoRequest(ChordID sender, ChordID receiver, OverlayKey key) {
		this(sender, receiver, "dhtObject");
		this.key = key;
	}
	
	public GetInfoRequest(ChordID sender, ChordID receiver, String type, int cmdID){
		this(sender, receiver, type);
		this.cmdID=cmdID;
	}

	public String getType() {
		return fieldName;
	}

	public OverlayKey getKey() {
		return key;
	}

	public int getCmdID(){
		return cmdID;
	}
	@Override
	public long getSize() {
		// TODO Auto-generated method stub
		return 0;
	}

}
