package de.tud.kom.p2psim.impl.overlay.dht.chord.messages;

import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordContact;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordID;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordKey;

/**
 * @author Yue Sheng
 * this message is used in the Lookup operation
 */
public class LookupRequest extends ChordMessage {
	// the key being searched
	private ChordKey key;

	// the starter of this lookup request
	private ChordContact starter = null;
	private int opID;

	private boolean forValue;

	/**
	 * @param sender
	 * @param receiver
	 * @param key
	 */
	public LookupRequest(ChordID sender, ChordID receiver, ChordKey key, boolean forValue) {
		super(sender, receiver);
		this.key = key;
		this.forValue=forValue;
	}

	@Override
	public long getSize() {
		// TODO Auto-generated method stub
		return 0;
	}
	
	public boolean forValue(){
		return forValue;
	}
	
	/* getters & setters*/
	public ChordContact getStarter() {
		return starter;
	}

	public ChordKey getKey() {
		return key;
	}

	public int getOpID() {
		return opID;
	}
	
	public void setStarter(ChordContact starter) {
		this.starter = starter;
	}

	public void setOpID(int opID) {
		this.opID = opID;
	}

}
