package de.tud.kom.p2psim.impl.overlay.dht.chord.operations;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordContact;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordNode;

/**
 * @author Yue Sheng
 * this operation checks the liveness of its master node's predecessor
 */
public class CheckPreOperation extends AbstractOperation<ChordNode, Object> {

	/**
	 * @param node
	 * @param callback
	 */
	public CheckPreOperation(ChordNode node, OperationCallback<Object> callback) {
		super(node, callback);
	}
	
	@Override
	protected void execute() {
		ChordContact pre = getComponent().getPre();
		if(pre==null){
			operationFinished(true);
			return;
		}
		// check if predecessor is alive
		CheckLivenessOperation ping = new CheckLivenessOperation(getComponent(), pre, new OperationCallback<Object>(){

			public void calledOperationFailed(Operation<Object> op) {
				getComponent().setPre(null);
				operationFinished(true);
			}

			public void calledOperationSucceeded(Operation<Object> op) {
				operationFinished(true);
				
			}
		});
		ping.scheduleImmediately();
	}

	@Override
	public Object getResult() {
		return this;
	}

}
