package de.tud.kom.p2psim.impl.overlay.dht.chord.operations;

import java.util.LinkedList;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayNode.PeerStatus;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordContact;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordNode;

public class CreateRingOperation extends AbstractOperation<ChordNode, Object> {

	/**
	 * @param node
	 * @param callback
	 */
	public CreateRingOperation(ChordNode node,
			OperationCallback<Object> callback) {
		super(node, callback);
	}

	@Override
	protected void execute() {
		ChordNode master = getComponent();
		master.setAlive(true);
		LinkedList<ChordContact> succ = new LinkedList<ChordContact>();
		for (int i = 0; i < ChordNode.r; i++) {
			succ.add(master.getLocalContact());
			assert succ.get(i).isAlive();
		}

		master.setPre(null);
		master.setSucc(succ);
		master.setPeerStatus(PeerStatus.PRESENT);
		master.enableBackgroundOps();
		master.getBootstrap().registerNode(master);
		System.out.println("createRing finished~~");// test
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}

}
