package de.tud.kom.p2psim.impl.overlay.dht.chord.operations;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.overlay.OverlayID;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordContact;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordID;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordNode;

/**
 * this node notifies that its predecessor is node "pre"
 * 
 * @author Yue Sheng
 */
public class NotifyOperation extends AbstractOperation<ChordNode, Object> {

	private ChordContact candidate = null; // another node claiming to be the
									// predecessor

	/**
	 * @param node
	 *            The master node
	 * @param pre
	 *            a node claiming to be the predecessor of master node
	 * @param callback
	 */
	public NotifyOperation(ChordNode node, ChordContact pre, OperationCallback<Object> callback) {
		super(node, callback);
		this.candidate = pre;
	}

	@Override
	protected void execute() {
		if (candidate == null)
			return;
		ChordNode master = getComponent();
		ChordContact pre = master.getPre();
		ChordID nId = master.getChordID(), nodeId = candidate.getOverlayID();
		if(pre == null || !pre.isAlive() || nodeId.between(pre.getOverlayID(), nId)){
			master.setPre(candidate);
		}
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}

}
