package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.routingtable;

import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.KademliaOverlayID;

/**
 * This interface groups methods that are offered to children by their parent
 * routing tree node.
 * 
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 * 
 */
interface ParentNode<T extends KademliaOverlayID> extends Node<T> {

    /**
     * Notifies this node of a new child. This node will create and hold a
     * reference to this new child, possibly overwriting an existing one.
     * 
     * @param child
     *                the new child (successor) node for this node.
     */
    public void registerNewChild(Node<T> child);

}
