package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.setup;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.transport.TransLayer;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.HKademliaNode;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.HKademliaOverlayID;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.KademliaOverlayContact;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

/**
 * Factory for HKademliaNodes.
 * 
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 */
public class HKademliaNodeFactory extends HAbstractNodeFactory {

    private final static Logger log = SimLogger
	    .getLogger(HKademliaNodeFactory.class);
    
    public HKademliaNodeFactory() {
	log.info("Using HKademliaNodeFactory.");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected HKademliaNode<HKademliaOverlayID> buildHierarchicalNode(
	    final HKademliaOverlayID id, final short port,
	    final TransLayer msgMgr) {
	final KademliaOverlayContact<HKademliaOverlayID> itsContact = new KademliaOverlayContact<HKademliaOverlayID>(
		id, msgMgr.getLocalTransInfo(port));
	final HKademliaNode<HKademliaOverlayID> newNode = new HKademliaNode<HKademliaOverlayID>(
		itsContact, msgMgr, config);
	return newNode;
    }

}
