package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.setup;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.common.Host;
import de.tud.kom.p2psim.api.transport.TransLayer;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.KBRKademliaNode;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.Node;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.HKademliaOverlayID;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.KademliaOverlayContact;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

public class KBRKademliaNodeFactory extends AbstractNodeFactory {

	private final static Logger log = SimLogger
	.getLogger(KademliaNodeFactory.class);

	public KBRKademliaNodeFactory() {
		log.info("Using KBRKademliaNodeFactory.");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected final Node<HKademliaOverlayID> buildNode(final HKademliaOverlayID id, 
			                                           final short port, final Host host) {
		
		final TransLayer msgMgr = host.getTransLayer();
		final KademliaOverlayContact<HKademliaOverlayID> itsContact = new KademliaOverlayContact<HKademliaOverlayID>(
				id, msgMgr.getLocalTransInfo(port));
		final KBRKademliaNode<HKademliaOverlayID> newNode = new KBRKademliaNode<HKademliaOverlayID>(itsContact, msgMgr, config);
		return newNode;
	}

}
