package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.setup;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.transport.TransLayer;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.Kandy2Node;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.HKademliaOverlayID;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.KademliaOverlayContact;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

/**
 * Factory for Kandy2Nodes.
 * 
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 */
public class Kandy2NodeFactory extends HAbstractNodeFactory {

    private final static Logger log = SimLogger
	    .getLogger(Kandy2NodeFactory.class);

    public Kandy2NodeFactory() {
	log.info("Using Kandy2NodeFactory.");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected Kandy2Node<HKademliaOverlayID> buildHierarchicalNode(
	    final HKademliaOverlayID id, final short port,
	    final TransLayer msgMgr) {
	final KademliaOverlayContact<HKademliaOverlayID> itsContact = new KademliaOverlayContact<HKademliaOverlayID>(
		id, msgMgr.getLocalTransInfo(port));
	final Kandy2Node<HKademliaOverlayID> newNode = new Kandy2Node<HKademliaOverlayID>(
		itsContact, msgMgr, config);
	return newNode;
    }

}
