package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.setup;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.transport.TransLayer;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.KandyNode;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.HKademliaOverlayID;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.KademliaOverlayContact;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

/**
 * Factory for KandyNodes.
 * 
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 */
public class KandyNodeFactory extends HAbstractNodeFactory {

    private final static Logger log = SimLogger
	    .getLogger(KandyNodeFactory.class);

    public KandyNodeFactory() {
	log.info("Using KandyNodeFactory.");
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected KandyNode<HKademliaOverlayID> buildHierarchicalNode(
	    final HKademliaOverlayID id, final short port,
	    final TransLayer msgMgr) {
	final KademliaOverlayContact<HKademliaOverlayID> itsContact = new KademliaOverlayContact<HKademliaOverlayID>(
		id, msgMgr.getLocalTransInfo(port));
	final KandyNode<HKademliaOverlayID> newNode = new KandyNode<HKademliaOverlayID>(
		itsContact, msgMgr, config);
	return newNode;
    }

}
