package de.tud.kom.p2psim.impl.overlay.gia.Analyzer;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import de.tud.kom.p2psim.api.analyzer.Analyzer;
import de.tud.kom.p2psim.api.analyzer.Analyzer.TransAnalyzer;
import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAByeMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAConnectAcceptMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAConnectMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAConnectionBreakMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAConnectionDeniedMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIADocumentsMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAPingMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAPongMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAQueryHitMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAQueryMessage;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIATokenMessage;
import de.tud.kom.p2psim.impl.simengine.Simulator;
import de.tud.kom.p2psim.impl.transport.AbstractTransMessage;

public class GIANetLoadAnalyzer implements Analyzer, TransAnalyzer {
	
	private Map<Integer, Integer> gesamtWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> queriesWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> queryHitsWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> pingsWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> pongsWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> connectWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> connectAcceptWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> connectDeniedWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> connectBreakWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> documentsWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> tokenWithTimeSteps = new HashMap<Integer, Integer>();
	private Map<Integer, Integer> byeWithTimeSteps = new HashMap<Integer, Integer>();
	private List<Integer> timeSteps = new LinkedList<Integer>();
	long pingSize = 0;
	long pongSize = 0;
	long querySize = 0;
	long queryHitSize = 0;
	long connectSize = 0;
	long connectDeniedSize = 0;
	long connectBreakSize = 0;
	long connectAcceptSize = 0;
	long tokenSize = 0;
	long documentsSize = 0;
	long byeSize = 0;
	int byeGesamt = 0;
	int pingGesamt  = 0;
	int pongGesamt  = 0;
	int queryGesamt  = 0;
	int queryHitGesamt  = 0;
	int connectGesamt  = 0;
	int connectDeniedGesamt  = 0;
	int connectAcceptGesamt  = 0;
	int connectBreakGesamt  = 0;
	int tokenGesamt  = 0;
	int documentsGesamt  = 0;
	int gesamtGesamt  = 0;

	public void start() {
		
	}

	public void stop(Writer output) {
		String f = "Analyzerausgabe4.dat";
	    FileWriter fstream = null;
	    
	    long byeGesamtLoad = 0;
	    long pingGesamtLoad   = 0;
		long pongGesamtLoad   = 0;
		long queryGesamtLoad   = 0;
		long queryHitGesamtLoad   = 0;
		long connectGesamtLoad   = 0;
		long connectDeniedGesamtLoad   = 0;
		long connectAcceptGesamtLoad   = 0;
		long connectBreakGesamtLoad   = 0;
		long tokenGesamtLoad   = 0;
		long documentsGesamtLoad   = 0;
		long gesamtGesamtLoad   = 0;
		try {
			fstream = new FileWriter(f);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write("	GIA-Analyzer	\n");
			out.write("	-----------------------	\n");
			out.write("	\n");
			out.write("	\n");
			out.write("Gesendete Messages pro Zeiteinheit:	\n");
			out.write("Zeit		Gesamt			Ping			Pong			Query			QueryHit		Connect			ConnectAccept		ConnectDenied		ConnectBreak			Token			Documents		Bye	\n");
			out.write("	\n");
			for (int i=0; i<timeSteps.size(); i++){
				int step1 = timeSteps.get(i) *10;
				int step2 = step1 + 10;
				int bye = 0;
				int ping = 0;
				int pong = 0;
				int query = 0;
				int queryHit = 0;
				int connect = 0;
				int connectDenied = 0;
				int connectAccept = 0;
				int connectBreak = 0;
				int token = 0;
				int documents = 0;
				int gesamt = 0;
				
				if (pingsWithTimeSteps.containsKey(timeSteps.get(i))){
					ping = pingsWithTimeSteps.get(timeSteps.get(i));
					pingGesamt += ping;
				}
				if (pongsWithTimeSteps.containsKey(timeSteps.get(i))){
					pong = pongsWithTimeSteps.get(timeSteps.get(i));
					pongGesamt += pong;
				}
				if (queriesWithTimeSteps.containsKey(timeSteps.get(i))){
					query = queriesWithTimeSteps.get(timeSteps.get(i));
					queryGesamt += query;
				}
				if (queryHitsWithTimeSteps.containsKey(timeSteps.get(i))){
					queryHit = queryHitsWithTimeSteps.get(timeSteps.get(i));
					queryHitGesamt += queryHit;
				}
				if (connectWithTimeSteps.containsKey(timeSteps.get(i))){
					connect = connectWithTimeSteps.get(timeSteps.get(i));
					connectGesamt += connect;
				}
				if (connectDeniedWithTimeSteps.containsKey(timeSteps.get(i))){
					connectDenied = connectDeniedWithTimeSteps.get(timeSteps.get(i));
					connectDeniedGesamt += connectDenied;
				}
				if (connectAcceptWithTimeSteps.containsKey(timeSteps.get(i))){
					connectAccept = connectAcceptWithTimeSteps.get(timeSteps.get(i));
					connectAcceptGesamt += connectAccept;
				}
				if (connectBreakWithTimeSteps.containsKey(timeSteps.get(i))){
					connectBreak = connectBreakWithTimeSteps.get(timeSteps.get(i));
					connectBreakGesamt += connectBreak;
				}
				if (tokenWithTimeSteps.containsKey(timeSteps.get(i))){
					token = tokenWithTimeSteps.get(timeSteps.get(i));
					tokenGesamt += token;
				}
				if (documentsWithTimeSteps.containsKey(timeSteps.get(i))){
					documents = documentsWithTimeSteps.get(timeSteps.get(i));
					documentsGesamt += documents;
				}
				if (byeWithTimeSteps.containsKey(timeSteps.get(i))){
					bye = byeWithTimeSteps.get(timeSteps.get(i));
					byeGesamt += bye;
				}
				if (gesamtWithTimeSteps.containsKey(timeSteps.get(i))){
					gesamt = gesamtWithTimeSteps.get(timeSteps.get(i));
					gesamtGesamt += gesamt;
				}
				out.write(step1 + "-" + step2 + "		" + gesamt + "			" + ping + "			" + pong + "			" + query + "			" + queryHit + "				" + connect + "					" + connectAccept + "				" + connectDenied + "				" + connectBreak + "				" + token + "				" + documents + "					" + bye + "	\n");
			}
			out.write("	\n");
			out.write(" ......................................................................................................................................................................................................................................................................................................................................................................................	\n");
			out.write("			" + gesamtGesamt + "			" + pingGesamt + "			" + pongGesamt + "			" + queryGesamt + "			" + queryHitGesamt + "			" + connectGesamt + "			" + connectAcceptGesamt + "			" + connectDeniedGesamt + "			" + connectBreakGesamt + "			" + tokenGesamt + "			" + documentsGesamt + "			" + byeGesamt + "			" + "	\n");
			out.write("	\n");
			out.write("	\n");
			out.write("	\n");
			out.write("Netzlast pro Zeiteinheit:	\n");
			out.write("Zeit		Gesamt			Ping			Pong			Query			QueryHit		Connect			ConnectAccept		ConnectDenied		ConnectBreak			Token			Documents			Bye	\n");
			out.write("	\n");
			for (int i=0; i<timeSteps.size(); i++){
				long byeLoad = 0;
				long pingLoad = 0;
				long pongLoad = 0;
				long queryLoad = 0;
				long queryHitLoad = 0;
				long connectLoad = 0;
				long connectDeniedLoad = 0;
				long connectAcceptLoad = 0;
				long connectBreakLoad = 0;
				long tokenLoad = 0;
				long documentsLoad = 0;

				
				if (pingsWithTimeSteps.containsKey(timeSteps.get(i))){
					pingLoad = pingsWithTimeSteps.get(timeSteps.get(i)) * pingSize;
					pingGesamtLoad += pingLoad;
				}
				if (pongsWithTimeSteps.containsKey(timeSteps.get(i))){
					pongLoad = pongsWithTimeSteps.get(timeSteps.get(i)) * pongSize;
					pongGesamtLoad += pongLoad;
				}
				if (queriesWithTimeSteps.containsKey(timeSteps.get(i))){
					queryLoad = queriesWithTimeSteps.get(timeSteps.get(i)) * querySize;
					queryGesamtLoad += queryLoad;
				}
				if (queryHitsWithTimeSteps.containsKey(timeSteps.get(i))){
					queryHitLoad = queryHitsWithTimeSteps.get(timeSteps.get(i)) * queryHitSize;
					queryHitGesamtLoad += queryHitLoad;
				}
				if (connectWithTimeSteps.containsKey(timeSteps.get(i))){
					connectLoad = connectWithTimeSteps.get(timeSteps.get(i)) * connectSize;
					connectGesamtLoad += connectLoad;
				}
				if (connectDeniedWithTimeSteps.containsKey(timeSteps.get(i))){
					connectDeniedLoad = connectDeniedWithTimeSteps.get(timeSteps.get(i)) * connectDeniedSize;
					connectDeniedGesamtLoad += connectDeniedLoad;
				}
				if (connectAcceptWithTimeSteps.containsKey(timeSteps.get(i))){
					connectAcceptLoad = connectAcceptWithTimeSteps.get(timeSteps.get(i)) * connectAcceptSize;
					connectAcceptGesamtLoad += connectAcceptLoad;
				}
				if (connectBreakWithTimeSteps.containsKey(timeSteps.get(i))){
					connectBreakLoad = connectBreakWithTimeSteps.get(timeSteps.get(i)) * connectBreakSize;
					connectBreakGesamtLoad += connectBreakLoad;
				}
				if (tokenWithTimeSteps.containsKey(timeSteps.get(i))){
					tokenLoad = tokenWithTimeSteps.get(timeSteps.get(i)) * tokenSize;
					tokenGesamtLoad += tokenLoad;
				}
				if (documentsWithTimeSteps.containsKey(timeSteps.get(i))){
					documentsLoad = documentsWithTimeSteps.get(timeSteps.get(i)) * documentsSize;
					documentsGesamtLoad += documentsLoad;
				}
				if (byeWithTimeSteps.containsKey(timeSteps.get(i))){
					byeLoad = byeWithTimeSteps.get(timeSteps.get(i)) * byeSize;
					byeGesamtLoad += byeLoad;
				}
				long gesamtLoad = pingLoad + pongLoad + queryLoad + queryHitLoad + connectLoad + connectDeniedLoad + connectAcceptLoad + connectBreakLoad + documentsLoad + tokenLoad + byeLoad;
				gesamtGesamtLoad += gesamtLoad;
				
				int step1 = timeSteps.get(i) *10;
				int step2 = step1 + 10;
				out.write(step1 + "-" + step2 + "		" + gesamtLoad + "				" + pingLoad + "			" + pongLoad + "			" + queryLoad + "			" + queryHitLoad + "				" + connectLoad + "					" + connectAcceptLoad + "				" + connectDeniedLoad + "				" + connectBreakLoad + "				" + tokenLoad + "				" + documentsLoad + "				" + byeLoad + "	\n");
			}
			out.write("	\n");
			out.write(" ......................................................................................................................................................................................................................................................................................................................................................................................	\n");
			out.write("			" + gesamtGesamtLoad + "			" + pingGesamtLoad + "			" + pongGesamtLoad + "			" + queryGesamtLoad + "			" + queryHitGesamtLoad + "			" + connectGesamtLoad + "			" + connectAcceptGesamtLoad + "			" + connectDeniedGesamtLoad + "			" + connectBreakGesamtLoad + "			" + tokenGesamtLoad + "			" + documentsGesamtLoad + "			" + byeGesamtLoad + "	\n");
			out.write("	\n");

			out.close();         
		} catch (IOException e) {
			e.printStackTrace();
		}                
		
	}

	public void transMsgReceived(AbstractTransMessage msg) {
		// TODO Auto-generated method stub
		
	}

	public void transMsgSent(AbstractTransMessage msg) {
		Message message = msg.getPayload();
		long time = Simulator.getInstance().getCurrentTime();
		int timeStep = (int) (time / 10000000);
		if (!timeSteps.contains(timeStep)){
			timeSteps.add(timeStep);
		}
		int gesamtAnzahl = 0;
		if(gesamtWithTimeSteps.containsKey(timeStep)){
			gesamtAnzahl = gesamtWithTimeSteps.get(timeStep);
		}
		gesamtAnzahl += 1;
		gesamtWithTimeSteps.put(timeStep, gesamtAnzahl);
		
		if (message instanceof GIAConnectMessage) {
			System.out.println(Simulator.getCurrentTime());
			int anzahl = 0;
			connectSize = ((GIAConnectMessage) message.getPayload()).getSize();
			if (connectWithTimeSteps.containsKey(timeStep)){
				anzahl = connectWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			connectWithTimeSteps.put(timeStep, anzahl);
			
		}
		else if (message instanceof GIAConnectionDeniedMessage) {
			int anzahl = 0;
			connectDeniedSize = ((GIAConnectionDeniedMessage) message.getPayload()).getSize();
			if (connectDeniedWithTimeSteps.containsKey(timeStep)){
				anzahl = connectDeniedWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			connectDeniedWithTimeSteps.put(timeStep, anzahl);				
		}
		else if (message instanceof GIAByeMessage) {
			int anzahl = 0;
			byeSize = ((GIAByeMessage) message.getPayload()).getSize();
			if (byeWithTimeSteps.containsKey(timeStep)){
				anzahl = byeWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			byeWithTimeSteps.put(timeStep, anzahl);
		
		}
		else if (message instanceof GIAConnectionBreakMessage) {
			int anzahl = 0;
			connectBreakSize = ((GIAConnectionBreakMessage) message.getPayload()).getSize();
			if (connectBreakWithTimeSteps.containsKey(timeStep)){
				anzahl = connectBreakWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			connectBreakWithTimeSteps.put(timeStep, anzahl);
		
		}
		else if (message instanceof GIATokenMessage) {
			int anzahl = 0;
			tokenSize = ((GIATokenMessage) message.getPayload()).getSize();
			if (tokenWithTimeSteps.containsKey(timeStep)){
				anzahl = tokenWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			tokenWithTimeSteps.put(timeStep, anzahl);
		
		}
		else if (message instanceof GIADocumentsMessage) {
			int anzahl = 0;
			documentsSize = ((GIADocumentsMessage) message.getPayload()).getSize();
			if (documentsWithTimeSteps.containsKey(timeStep)){
				anzahl = documentsWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			documentsWithTimeSteps.put(timeStep, anzahl);
		
		}
		else if (message instanceof GIAConnectAcceptMessage) {
			int anzahl = 0;
			connectAcceptSize = ((GIAConnectAcceptMessage) message.getPayload()).getSize();
			if (connectAcceptWithTimeSteps.containsKey(timeStep)){
				anzahl = connectAcceptWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			connectAcceptWithTimeSteps.put(timeStep, anzahl);
		
		}
		else if (message instanceof GIAPingMessage) {
			int anzahl = 0;
			pingSize = ((GIAPingMessage) message.getPayload()).getSize();
			if (pingsWithTimeSteps.containsKey(timeStep)){
				anzahl = pingsWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			pingsWithTimeSteps.put(timeStep, anzahl);

		} 
		else if (message instanceof GIAPongMessage) {
			int anzahl = 0;
			pongSize = ((GIAPongMessage) message.getPayload()).getSize();
			if (pongsWithTimeSteps.containsKey(timeStep)){
				anzahl = pongsWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			pongsWithTimeSteps.put(timeStep, anzahl);
		
		} 
		else if (message instanceof GIAQueryMessage) {
			int anzahl = 0;
			querySize = ((GIAQueryMessage) message.getPayload()).getSize();
			if (queriesWithTimeSteps.containsKey(timeStep)){
				anzahl = queriesWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			queriesWithTimeSteps.put(timeStep, anzahl);
		}
		else if (message instanceof GIAQueryHitMessage) {
			int anzahl = 0;
			queryHitSize = ((GIAQueryHitMessage) message.getPayload()).getSize();
			if (queryHitsWithTimeSteps.containsKey(timeStep)){
				anzahl = queryHitsWithTimeSteps.get(timeStep);
			}
			anzahl += 1;
			queryHitsWithTimeSteps.put(timeStep, anzahl);
		}
	}

}
