package de.tud.kom.p2psim.impl.overlay.gia.Analyzer;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.analyzer.Analyzer;
import de.tud.kom.p2psim.api.analyzer.Analyzer.OperationAnalyzer;
import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.overlay.OverlayNode;
import de.tud.kom.p2psim.impl.overlay.gia.GIABootstrapManager;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayNode;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

public class GIAOperationAnalyzer implements Analyzer, OperationAnalyzer{

	protected final static Logger log = SimLogger.getLogger(GIAOperationAnalyzer.class);
	private Map<Integer, LinkedList<OverlayNode>> sortedByCapacities;
	private LinkedList<OverlayNode> new10000PeersList = new LinkedList<OverlayNode>();
	private LinkedList<OverlayNode> new1000PeersList = new LinkedList<OverlayNode>();
	private LinkedList<OverlayNode> new100PeersList = new LinkedList<OverlayNode>();
	private LinkedList<OverlayNode> new10PeersList = new LinkedList<OverlayNode>();
	private LinkedList<OverlayNode> new1PeersList = new LinkedList<OverlayNode>();
	
	public void start() {
		// TODO Auto-generated method stub
		this.sortedByCapacities = new HashMap<Integer, LinkedList<OverlayNode>>();
		LinkedList<OverlayNode> newEmptyList = new LinkedList<OverlayNode>();
		this.sortedByCapacities.put(10000, newEmptyList);
		this.sortedByCapacities.put(1000, newEmptyList);
		this.sortedByCapacities.put(100, newEmptyList);
		this.sortedByCapacities.put(10, newEmptyList);
		this.sortedByCapacities.put(1, newEmptyList);
	}

	public void stop(Writer output) {
		List<OverlayNode> activeNodes = GIABootstrapManager.getInstance().getNodes();
		for(OverlayNode node : activeNodes){
			int capacity = ((GIAOverlayNode) node).getCapacity();
			if (capacity == 10000){
				if(!new10000PeersList.contains(node)){
					new10000PeersList.add(node);
				}
			} else if (capacity == 1000){
				if(!new1000PeersList.contains(node)){
					new1000PeersList.add(node);
				}
			} else if (capacity == 100){
				if(!new100PeersList.contains(node)){
					new100PeersList.add(node);
				}
			} else if (capacity == 10){
				if(!new10PeersList.contains(node)){
					new10PeersList.add(node);
				}
			} else if (capacity == 1){
				if(!new1PeersList.contains(node)){
					new1PeersList.add(node);
				}
			}
/**			LinkedList<OverlayNode> newList = new LinkedList<OverlayNode>();
			newList = sortedByCapacities.get(capacity);
			for (int i=0; i<newList.size(); i++){
				System.out.println("--" + newList.get(i).getOverlayID() + "    " + capacity + "   ");
			}
			newList.add(node);
			System.out.println(node.getOverlayID() + " dazugef�gt");
//			sortedByCapacities.remove(capacity);
			sortedByCapacities.put(capacity, newList);
			GIAOperationAnalyzer.log.debug(id+ " " +capacity+ " " + numberOfNeighbors);
			for (int i=0; i<newList.size(); i++){
				System.out.println(newList.get(i).getOverlayID() + "    " + capacity + "   ");
			}
**/
		}
	
		String f = "Analyzerausgabe.dat";
	    FileWriter fstream = null;
		try {
			fstream = new FileWriter(f);

			int counter = 1;
			BufferedWriter out = new BufferedWriter(fstream);
			out.write("	GIA-Analyzer	\n");
			out.write("	-----------------------	\n");
			out.write("	\n");
			out.write("	\n");			out.write("# Capacity		Node		Neighbors		Satisfaction		\n");
			out.write("# \n");
			

			for(int i=0; i<this.new10000PeersList.size(); i++){
				out.write(counter + "	" + "10000		" + new10000PeersList.get(i).getOverlayID()+ "			" + ((GIAOverlayNode)new10000PeersList.get(i)).getNumberOfNeighbors() + "			"+ ((GIAOverlayNode)new10000PeersList.get(i)).getSatisfaction() + "		\n");                
				counter++;
			}
                        
            for(int i=0; i<this.new1000PeersList.size(); i++){
                out.write(counter + "	" + "1000		" + new1000PeersList.get(i).getOverlayID()+ "			" + ((GIAOverlayNode)new1000PeersList.get(i)).getNumberOfNeighbors()  + "			"+ ((GIAOverlayNode)new1000PeersList.get(i)).getSatisfaction() +  "		\n");
                counter++;
			}
                        
            for(int i=0; i<this.new100PeersList.size(); i++){
                out.write(counter + "	" + "100			" + new100PeersList.get(i).getOverlayID()+ "			" + ((GIAOverlayNode)new100PeersList.get(i)).getNumberOfNeighbors()  + "			"+ ((GIAOverlayNode)new100PeersList.get(i)).getSatisfaction() +  "		\n");
                counter++;
			}
                       
            for(int i=0; i<this.new10PeersList.size(); i++){
            	out.write(counter + "	" + "10			" + new10PeersList.get(i).getOverlayID()+ "			" + ((GIAOverlayNode)new10PeersList.get(i)).getNumberOfNeighbors()  + "			"+ ((GIAOverlayNode)new10PeersList.get(i)).getSatisfaction() +  "		\n");
            	counter++;
			}
                        
            for(int i=0; i<this.new1PeersList.size(); i++){
                out.write(counter + "	" + "1			" + new1PeersList.get(i).getOverlayID()+ "			" + ((GIAOverlayNode)new1PeersList.get(i)).getNumberOfNeighbors()  + "			"+ ((GIAOverlayNode)new1PeersList.get(i)).getSatisfaction() +  "		\n");
                counter++;
			}
            
            out.close();
                        
		} catch (IOException e) {
			e.printStackTrace();
		}                
   
	}

	
	public void operationFinished(Operation<?> op) {
		// TODO Auto-generated method stub
		
	}

	public void operationInitiated(Operation<?> op) {
		// TODO Auto-generated method stub
		
	}
	
}
