package de.tud.kom.p2psim.impl.overlay.gia;

import java.math.BigInteger;

import de.tud.kom.p2psim.impl.simengine.Simulator;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAConfiguration {
	public final static int GIA_PING_MAX_TTL = 3;
	public final static int GIA_QUERY_MAX_TTL = 512;
	public final static int GIA_QUERYFLOOD_MAX_TTL = 4;
	public final static double RELATIVE_CONNECT_SLOTS = 0.2;
	public final static int QUERY_KEY_MASK = 7;
	public final static int GIA_MAXREPLIES = 1;
	public final static int GIA_MINCONTACTS = 2;
	public final static int GIA_MAXCONTACTS = 48;
	public final static long GIA_SCHEDULEPING = 6000000;
	public final static long GIA_TIMEOUT = 8000000;
	public final static long GIA_QUERYTIMEOUT = 5000000;
	public final static long GIA_SCHEDULEDCONNECT = 80000000;
	public final static long GIA_SCHEDULEDNOTOPOLOGYADAPTION = 10000000;
	public final static long GIA_SCHEDULEDLEAVE = 20000000;
	public final static long GIA_SCHEDULEDCHECKNEIGHBORS = 600000;
	public final static long GIA_AGGRESSIONFACTOR = 100;
	public final static double GIA_QUERYRATE = 0.1;
 	
	public final static boolean GIA_CHURN = false;
	public final static long GIA_SESSIONTIMEBENEFACTOR = 600;
	public final static long GIA_OFFTIMEBENEFACTOR = 200;
	public final static long GIA_SESSIONTIMEPEER = 60;
	public final static long GIA_OFFTIMEPEER = 60;
	public final static double GIA_CHURNFACTOR = 0.5;
	
	private static final int TIME_BITS_IGNORE = 6;
	private static final int TIME_BITS = 30;
	private static final int ID_BITS = 11;
	public static final int GIA_HYSTERESISFACTOR = 5;
	
	
	public static BigInteger generateDescriptor(BigInteger id) {
		
		BigInteger rand = BigInteger.valueOf(Simulator.getRandom().nextLong());
		BigInteger time = BigInteger.valueOf(Simulator.getCurrentTime()).divide(BigInteger.valueOf(2).pow(TIME_BITS_IGNORE));
		
		BigInteger timeMultiplicator = BigInteger.valueOf(2).pow(TIME_BITS);
		
		// mask time
		time = time.and(BigInteger.valueOf(2).pow(TIME_BITS).subtract(BigInteger.valueOf(1)));
		// mask id and shift
		id = id.and(BigInteger.valueOf(2).pow(ID_BITS).subtract(BigInteger.valueOf(1))).shiftLeft(TIME_BITS);
		// mask rand
		rand = rand.andNot(BigInteger.valueOf(2).pow(TIME_BITS + ID_BITS).subtract(BigInteger.valueOf(1)));
		
		return time.add(id).add(rand);
	}
}