package de.tud.kom.p2psim.impl.overlay.gia;

import java.math.BigInteger;


import de.tud.kom.p2psim.api.overlay.OverlayID;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAOverlayID implements OverlayID{
	
	private BigInteger giaID;
	
	/**
	 * @param giaID big Integer value of the overlay ID
	 */
	public GIAOverlayID(BigInteger giaID){
		this.giaID = giaID;
	}
	
	/**
	 * @param giaID Integer value of the overlay ID
	 */
	public GIAOverlayID(int giaID){
		this.giaID = BigInteger.valueOf(giaID);
	}
	
	public byte[] getBytes(){	
		return null;
	}
	
	public Object getUniqueValue(){
		return this.giaID;
	}
	
	/**
	 * @return the overlay ID
	 */
	public BigInteger getValue(){
		return this.giaID;
	}
	
	public int compareTo(OverlayID arg0){
		GIAOverlayID m = (GIAOverlayID)arg0;
		return this.giaID.compareTo(m.getValue());
	}
	
	/**
	 * @param id overlay ID
	 * @return the difference between this overlay ID and id
	 */
	public int getDistance(GIAOverlayID id){
		BigInteger oid = id.getValue();
		return this.giaID.subtract(oid).abs().intValue();
	}
	
	/**
	 * @param o overlay ID
	 * @return true if o equals this overlay ID
	 */
	public boolean equals(GIAOverlayID o){
		return this.giaID.compareTo(o.getValue()) == 0;
	}
	
	public String toString() {
		return this.giaID.toString();
	}
}