package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public abstract class BaseMessage extends AbstractOverlayMessage<GIAOverlayID> {

	private int ttl;
	private int hops;
	private BigInteger descriptor;
	private final static long GIA_BASE_MESSAGE_SIZE = 23;
	
	/**
	 * @param sender overlay ID of sender
	 * @param receiver overlay ID of receiver
	 * @param ttl time to live for message
	 * @param hops number of hops already taken
	 * @param descriptor message ID
	 */
	public BaseMessage(GIAOverlayID sender, GIAOverlayID receiver, int ttl, int hops, BigInteger descriptor) {
		super(sender, receiver);
		this.ttl = ttl;
		this.hops = hops;
		this.descriptor = descriptor;
	}
	
	public Message getPayload() {
		return this;
	}
	
	/**
	 * @return time to live
	 */
	public Integer getTTL() {
		return ttl;
	}
	
	/**
	 * @return return hop count
	 */
	public Integer getHops() {
		return hops;
	}
	
	/**
	 * @return message ID
	 */
	public BigInteger getDescriptor() {
		return descriptor;
	}

	public long getSize() {
		return GIA_BASE_MESSAGE_SIZE;
	}
}