package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;


/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAByeMessage extends AbstractOverlayMessage<GIAOverlayID>{

	private String errorCode;  // Grund f�r die Beendigung/Zur�cksetzung der Verbindung
	private final static long GIA_BYE_MESSAGE_SIZE = 23;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param errorCode reason for the bye message
	 */
	public GIAByeMessage(GIAOverlayID sender, GIAOverlayID receiver, String errorCode) {
		super(sender, receiver);
		this.errorCode = errorCode;
	}

	/**
	 * @return error code
	 */
	public String getErrorCode(){
		return errorCode;
	}
	
	public Message getPayload() {
		return this;
	}

	public long getSize() {
		// TODO Size festlegen
		return GIA_BYE_MESSAGE_SIZE ;
	}

}
