package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAConnectMessage extends AbstractOverlayMessage<GIAOverlayID> {

	private final static long GIA_CONNECT_MESSAGE_SIZE = 24;
	private GIAOverlayContact contact;
	private int numberOfNeighbors;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param contact contact info of the sender
	 * @param numberOfNeighbors number of neighbors of the sender
	 */
	public GIAConnectMessage(GIAOverlayID sender, GIAOverlayID receiver, GIAOverlayContact contact, int numberOfNeighbors) {
		super(sender, receiver);
		this.contact = contact;
		this.numberOfNeighbors = numberOfNeighbors;
	}

	public Message getPayload() {
		return this;
	}
	
	/**
	 * @return contact info
	 */
	public GIAOverlayContact getContact() {
		return contact;
	}

	public long getSize() {
		return GIA_CONNECT_MESSAGE_SIZE;
	}
	
	/**
	 * @return number of neighbors
	 */
	public int getNumberOfNeighbors(){
		return numberOfNeighbors;
	}
		
}