package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;


/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAConnectionBreakMessage  extends AbstractOverlayMessage<GIAOverlayID>{
	
	private final static long GIA_CONNECT_BREAK_MESSAGE_SIZE = 24;
	private String errorCode;  // Grund f�r die Beendigung/Zur�cksetzung der Verbindung
	private GIAOverlayContact contact;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param errorCode reason for the connection break
	 */
	public GIAConnectionBreakMessage(GIAOverlayID sender, GIAOverlayID receiver, GIAOverlayContact contact, String errorCode) {
		super(sender, receiver);
		this.errorCode = errorCode;
		this.contact = contact;
	}

	/**
	 * @return error code
	 */
	public String getErrorCode(){
		return errorCode;
	}
	
	public Message getPayload() {
		return this;
	}

	public long getSize() {
		// TODO Size festlegen
		return GIA_CONNECT_BREAK_MESSAGE_SIZE;
	}
	
	public GIAOverlayContact getContact(){
		return contact;
	}


}
