package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAConnectionDeniedMessage  extends AbstractOverlayMessage<GIAOverlayID>{

	private final static long GIA_CONNECT_DENIED_MESSAGE_SIZE = 24;
	private String errorCode;   // Grund f�r die Beendigung/Zur�cksetzung der Verbindung

	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param errorCode reason for the denied connection
	 */
	public GIAConnectionDeniedMessage(GIAOverlayID sender, GIAOverlayID receiver, String errorCode) {
		super(sender, receiver);
		this.errorCode = errorCode;
	}

	/**
	 * @return error code
	 */
	public String getErrorCode(){
		return errorCode;
	}
	
	public Message getPayload() {
		return this;
	}

	public long getSize() {
		//TODO: Size festlegen
		return GIA_CONNECT_DENIED_MESSAGE_SIZE;
	}

}
