package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import java.util.List;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gia.FileSharingKey;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIADocumentsMessage extends AbstractOverlayMessage<GIAOverlayID>{

	private final static long GIA_DOCUMENTS_MESSAGE_SIZE = 23;
	private List<Integer> documents;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param documents list of documents of the sender
	 */
	public GIADocumentsMessage(GIAOverlayID sender, GIAOverlayID receiver, List<Integer> documents){
		super(sender, receiver);
		this.documents = documents;
		
	}
	
	/**
	 * @return documents
	 */
	public List<Integer> getDocuments(){
		return documents;
	}
	
	public Message getPayload() {
		return this;
	}

	public long getSize() {
		// TODO Auto-generated method stub
		return GIA_DOCUMENTS_MESSAGE_SIZE + documents.size()*4;
	}

}
