package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAPongMessage extends BaseMessage{
	
	private static final long GIA_PONG_MESSAGE_SIZE = 14;
	private GIAOverlayContact contact;
	private int numberOfNeighbors;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param ttl time to live of the message
	 * @param hops hop count for the message
	 * @param descriptor message ID
	 * @param contact contact info of sender
	 * @param numberOfNeighbors number of neighbors of sender
	 */
	public GIAPongMessage(GIAOverlayID sender, GIAOverlayID receiver, int ttl, int hops, BigInteger descriptor, GIAOverlayContact contact, int numberOfNeighbors) {
		super(sender, receiver, ttl, hops, descriptor);
		this.contact = contact;
		this.numberOfNeighbors = numberOfNeighbors;
	}
	
	/**
	 * @return contact info
	 */
	public GIAOverlayContact getContact() {
		return contact;
	}
	 
	public long getSize(){
		return super.getSize() + GIA_PONG_MESSAGE_SIZE;
	}
	
	/**
	 * @return number of neighbors
	 */
	public int getNumberOfNeighbors(){
		return numberOfNeighbors;
	}

}
