package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import java.math.BigInteger;
import java.util.List;

import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gia.FileSharingKey;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;
import de.tud.kom.p2psim.impl.simengine.Simulator;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAQueryIDMessage extends BaseMessage {
	
	private static final long GIA_QUERY_MESSAGE_SIZE = 3;
	private long searchStringSize;
	private Integer id;
	private GIAOverlayContact initiator;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param ttl time to live of the message
	 * @param hops hop count for the message
	 * @param descriptor message ID
	 * @param id OverlayID searched for
	 * @param initiator contact info of the initiator of the query
	 */
	public GIAQueryIDMessage(GIAOverlayID sender, GIAOverlayID receiver, int ttl, int hops, BigInteger descriptor, Integer id, GIAOverlayContact initiator) {
		super(sender, receiver, ttl, hops, descriptor);
		searchStringSize = (long) (Simulator.getRandom().nextDouble() * 40);
		this.id = id;
		this.initiator = initiator;
	}

	/**
	 * @return document
	 */
	public Integer getID() {
		return this.id;
	}
	
	public long getSize() { 
		return super.getSize() + GIA_QUERY_MESSAGE_SIZE + searchStringSize;
	}
	
	/**
	 * @return contact info of initiator
	 */
	public GIAOverlayContact getInitiator(){
		return initiator;
	}
}
