package de.tud.kom.p2psim.impl.overlay.gia.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIATokenMessage extends AbstractOverlayMessage<GIAOverlayID>{

	private static long GIA_TOKEN_SIZE = 23;
	private long tokenRate;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param tokenRate rate at witch the receiver can send to the sender
	 */
	public GIATokenMessage(GIAOverlayID sender, GIAOverlayID receiver, long tokenRate) {
		super(sender, receiver);
		this.tokenRate = tokenRate;
	}

	public Message getPayload() {
		return this;
	}

	public long getSize() {
		return GIA_TOKEN_SIZE;
	}
	
	/**
	 * @return token rate
	 */
	public long getTokenRate() {
		return tokenRate;
	}

}
