package de.tud.kom.p2psim.impl.overlay.gia.Operations;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.transport.TransInfo;
import de.tud.kom.p2psim.api.transport.TransProtocol;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayID;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayNode;
import de.tud.kom.p2psim.impl.overlay.gia.Messages.GIAConnectMessage;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 22.06.2008
 *
 */
public class GIAConnectOperation extends AbstractOperation<GIAOverlayNode, Object> {

	private GIAOverlayNode node;
	private TransInfo connectInfo;
	private int numberOfNeighbors;
	
	/**
	 * @param node initiator of this operation
	 * @param connectInfo transport info
	 * @param numberOfNeighbors number of neighbors
	 * @param callback
	 */
	public GIAConnectOperation(GIAOverlayNode node, TransInfo connectInfo, int numberOfNeighbors, OperationCallback<Object> callback) {
		super(node, callback);
		this.connectInfo = connectInfo;
		this.node = node;
		this.numberOfNeighbors = numberOfNeighbors;
	}

	@Override
	protected void execute() {
		GIAConnectMessage message = new GIAConnectMessage((GIAOverlayID) this.node.getOverlayID(), null, this.getComponent().getOwnContactData(), this.numberOfNeighbors);
		node.getTransLayer().send(message, connectInfo, node.getPort(), TransProtocol.UDP);
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}

}
