package de.tud.kom.p2psim.impl.overlay.gia.Operations;

import java.lang.Math;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gia.GIAConfiguration;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayNode;


/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 25.06.2008
 *
 */
public class GIAScheduleConnectOperation extends AbstractOperation<GIAOverlayNode, Object>{
	
	private static int counter = 0;
	long delay;
	long k = GIAConfiguration.GIA_AGGRESSIONFACTOR;
	long t = GIAConfiguration.GIA_SCHEDULEDCONNECT;
	float s;
	static double power;
	boolean topologyAdaption;
	
	/**
	 * @param node initiator of this operation
	 * @param callback
	 */
	public GIAScheduleConnectOperation(GIAOverlayNode node, boolean topologyAdaption, OperationCallback<Object> callback){
		super(node, callback);
		s = this.getComponent().getSatisfaction();
		this.topologyAdaption = topologyAdaption;
	}

	@Override
	protected void execute() {
		
		counter++;
		if (counter % 8 == 7){
			if (this.getComponent().getNumberOfNeighbors() < 3 && this.getComponent().getSatisfaction() <= 0.3){
				this.getComponent().join();
			}
		}	
		if(this.getComponent().isActive()){
			this.getComponent().connect();
			if(topologyAdaption){
				delay = (long) (t * Math.pow(k, -(1 - s)));
				
			}
			else{
				if(this.getComponent().getNodesRoutingTable().allContacts().size() < GIAConfiguration.GIA_MAXCONTACTS){
					delay = GIAConfiguration.GIA_SCHEDULEDNOTOPOLOGYADAPTION;
				}
				else{
					delay = 300000000;
				}
			}	
			
			this.scheduleWithDelay(delay);
		}
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}
	
}
