package de.tud.kom.p2psim.impl.overlay.gia.Operations;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gia.GIAConfiguration;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayNode;
import de.tud.kom.p2psim.impl.simengine.Simulator;

/**
 * @author Jonas K�hne
 * @author Robert Schadler
 * @version 3.0, 29.06.2008
 *
 */
public class GIAScheduleJoinOperation extends AbstractOperation<GIAOverlayNode, Object>{

	int userType;
		/**
		 * @param node (initiator of this Operation)
		 * @param callback
		 */
		public GIAScheduleJoinOperation(GIAOverlayNode node, int userType, OperationCallback<Object> callback){
			super(node, callback);
			this.userType = userType;
		}

		@Override
		protected void execute() {
			this.getComponent().setActive();
			this.getComponent().join();	
			
			GIAScheduleLeaveOperation leave = new GIAScheduleLeaveOperation(this.getComponent(), userType, new OperationCallback<Object>(){
				public void calledOperationFailed(Operation<Object> op) {
					//
				}
				public void calledOperationSucceeded(Operation<Object> op) {
					//
				}});
			int random = 30 - Simulator.getRandom().nextInt(60); 
			if(userType == 0){
				leave.scheduleWithDelay((GIAConfiguration.GIA_SESSIONTIMEBENEFACTOR + random)*Simulator.SECOND_UNIT);
			}
			else if(userType == 1){
				leave.scheduleWithDelay((GIAConfiguration.GIA_SESSIONTIMEPEER + random)*Simulator.SECOND_UNIT);
			}
			operationFinished(true);
		}

		@Override
		public Object getResult() {
			return this;
		}
}
