package de.tud.kom.p2psim.impl.overlay.gia.Operations;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gia.GIAConfiguration;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayNode;
import de.tud.kom.p2psim.impl.simengine.Simulator;

/**
 * @author Jonas K�hne
 * @author Robert Schadler
 * @version 3.0, 29.06.2008
 *
 */
public class GIAScheduleLeaveOperation extends AbstractOperation<GIAOverlayNode, Object>{

	int userType;
	GIAOverlayNode node;
	/**
	 * @param node (initiator of this Operation)
	 * @param callback
	 */
	public GIAScheduleLeaveOperation(GIAOverlayNode node, int userType, OperationCallback<Object> callback){
		super(node, callback);
		this.userType = userType;
		this.node = node;
	}

	@Override
	protected void execute() {
		this.getComponent().leave(false);
		
		GIAScheduleJoinOperation join = new GIAScheduleJoinOperation(node, userType, new OperationCallback<Object>(){
			public void calledOperationFailed(Operation<Object> op) {
				//
			}
			public void calledOperationSucceeded(Operation<Object> op) {
				//
			}});
		int random = 30 - Simulator.getRandom().nextInt(60);
		if(userType == 0){
			join.scheduleWithDelay((GIAConfiguration.GIA_OFFTIMEBENEFACTOR + random)*Simulator.SECOND_UNIT);
		}
		else if(userType == 1 && random >= -20){
			join.scheduleWithDelay((GIAConfiguration.GIA_OFFTIMEPEER + random)*Simulator.SECOND_UNIT);
		}
		else if(userType == 1){
			join.scheduleWithDelay(1*Simulator.SECOND_UNIT);
		}
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}
	
}
