package de.tud.kom.p2psim.impl.overlay.gia.Operations;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gia.GIAConfiguration;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayNode;
import de.tud.kom.p2psim.impl.simengine.Simulator;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

/**
 * @author Robert Schadler
 * @author Jonas K�hne
 * @version 3.0, 25.06.2008
 *
 */
public class GIASchedulePingOperation extends AbstractOperation<GIAOverlayNode, Object> {
	
	long delay;
	private static int counter = 0;
	private static int secCounter = 0;
	
	protected final static Logger log = SimLogger.getLogger(GIASchedulePingOperation.class);

	/**
	 * @param node initiator of this operation
	 * @param delay interval this message should be send in
	 * @param callback
	 */
	public GIASchedulePingOperation(GIAOverlayNode node, long delay, OperationCallback<Object> callback) {
		super(node, callback);
		this.delay = delay;
	}

	@Override
	protected void execute() {
		counter++;
//		GIASchedulePingOperation.log.debug(Simulator.getCurrentTime()+ " - " +this.getComponent().getOverlayID() + " inactive neighbors " +this.getComponent().getNodesRoutingTable().inactiveContacts().size());
		
		if(this.getComponent().isActive()){
			if ((counter % 4 == 0 && this.getComponent().getNodesRoutingTable().allContacts().size() < (this.getComponent().getMaxContacts()/2) && this.getComponent().getNodesRoutingTable().inactiveContacts().size() < (this.getComponent().getMaxContacts()/2)) || this.getComponent().getNumberOfNeighbors() < GIAConfiguration.GIA_MINCONTACTS){
				secCounter++;
				if (secCounter % 6 == 0){
					for(GIAOverlayContact receiver : this.getComponent().getNodesRoutingTable().allContacts()){
						//GIASchedulePingOperation.log.debug(Simulator.getCurrentTime()+ " - " +this.getComponent().getOverlayID() + " erkundet die welt " +receiver.getOverlayID());
						GIAPingOperation ping = new GIAPingOperation(this.getComponent(), receiver, new OperationCallback<Object>(){
								public void calledOperationFailed(Operation<Object> op) {
									//
								}
								public void calledOperationSucceeded(Operation<Object> op) {
									//
								}});
						ping.scheduleImmediately();
					}
				} else {
					for(GIAOverlayContact receiver : this.getComponent().getNodesRoutingTable().allContacts()){
						GIAPingOperation ping = new GIAPingOperation(this.getComponent(), receiver, (GIAConfiguration.GIA_PING_MAX_TTL/2), 0, null, new OperationCallback<Object>(){
								public void calledOperationFailed(Operation<Object> op) {
									//
								}
								public void calledOperationSucceeded(Operation<Object> op) {
									//
								}});
						ping.scheduleImmediately();
					}
				}
				
				
			} else if (counter % 30 == 1 && this.getComponent().getNodesRoutingTable().inactiveContacts().size() < 35){
				for(GIAOverlayContact receiver : this.getComponent().getNodesRoutingTable().allContacts()){
					//GIASchedulePingOperation.log.debug(Simulator.getCurrentTime()+ " - " +this.getComponent().getOverlayID() + " erkundet die welt " +receiver.getOverlayID());
					GIAPingOperation ping = new GIAPingOperation(this.getComponent(), receiver, new OperationCallback<Object>(){
							public void calledOperationFailed(Operation<Object> op) {
								//
							}
							public void calledOperationSucceeded(Operation<Object> op) {
								//
							}});
					ping.scheduleImmediately();
				} 
			} else {
				for(GIAOverlayContact receiver : this.getComponent().getNodesRoutingTable().allContacts()){
					//GIASchedulePingOperation.log.debug(Simulator.getCurrentTime()+ " - " +this.getComponent().getOverlayID() + " sends keep alive " +receiver.getOverlayID());
					GIAPingOperation ping = new GIAPingOperation(this.getComponent(), receiver, 1, 0, null, new OperationCallback<Object>(){
							public void calledOperationFailed(Operation<Object> op) {
								//
							}
							public void calledOperationSucceeded(Operation<Object> op) {
								//
							}});
					ping.scheduleImmediately();
				}
			}
		}
		if(this.getComponent().isActive()){
			this.scheduleWithDelay(delay);
		}
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}
}
