package de.tud.kom.p2psim.impl.overlay.gia.Operations;

import java.lang.Math;
import org.apache.log4j.*;


import de.tud.kom.p2psim.impl.util.logging.SimLogger;
import de.tud.kom.p2psim.impl.util.stat.distributions.zipf.ZipfDistribution;
import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gia.FileFactory;
import de.tud.kom.p2psim.impl.overlay.gia.FileSharingKey;
import de.tud.kom.p2psim.impl.overlay.gia.GIAConfiguration;
import de.tud.kom.p2psim.impl.overlay.gia.GIAOverlayNode;
import de.tud.kom.p2psim.impl.overlay.gia.Operations.GIAQueryOperation;
import de.tud.kom.p2psim.impl.simengine.Simulator;

/**
 * @author Jonas K�hne
 * @author Robert Schadler
 * @version 3.0, 29.06.2008
 *
 */
public class GIAScheduleQueryOperation extends AbstractOperation<GIAOverlayNode, Object>{

	protected final static Logger log = SimLogger.getLogger(GIAScheduleQueryOperation.class);
	private long delay;
	private boolean biasedRandomWalk;
	private int maxTTL;
	
	/**
	 * @param node (initiator of this operation)
	 * @param callback
	 */
	public GIAScheduleQueryOperation(GIAOverlayNode node, boolean biasedRandomWalk, OperationCallback<Object> callback){
		super(node, callback);
		this.biasedRandomWalk = biasedRandomWalk;
	}

	@Override
	protected void execute() {
		int file = 0;
		int key = 0;
		for(int i = 0; i < 5; i++){
			key = FileFactory.getInstance().getZipf().returnRank();
			file = key;
			if(FileFactory.getInstance().getFileSharingKeys().contains(file)){
				i = 5;
			}
		}
//		FileSharingKey file = FileFactory.getInstance().getFileKey(Simulator.getRandom().nextInt(FileFactory.getInstance().getNumberOfFiles()));
		if(this.getComponent().isActive()){	
			if(!this.getComponent().getDocuments().contains(file)){
				//System.out.println("query for " +file);
				if(biasedRandomWalk){
					maxTTL = GIAConfiguration.GIA_QUERY_MAX_TTL;
				}
				else{
					maxTTL = GIAConfiguration.GIA_QUERYFLOOD_MAX_TTL;
				}
				GIAQueryOperation query = new GIAQueryOperation(this.getComponent(), file, maxTTL, biasedRandomWalk, new OperationCallback<Object>(){
						public void calledOperationFailed(Operation<Object> op) {
							//
						}
						public void calledOperationSucceeded(Operation<Object> op) {
							//
						}});			
//				GIAScheduleQueryOperation.log.debug(this.getComponent().getOverlayID() + " sendet Query mit Key: " + file);
				query.scheduleImmediately();
			}
//			else this.getComponent().sendQuery();
//			this.scheduleImmediately();
			delay = calculateDelay();
//			GIAScheduleQueryOperation.log.debug("Delay: " + delay);
			this.scheduleWithDelay(delay);
		}
		operationFinished(true);
	}
	
	

	@Override
	public Object getResult() {
		return this;
	}
	
	public long calculateDelay(){
		double tempDelay;
		tempDelay = (50 - Simulator.getRandom().nextInt(5)- (10 * GIAConfiguration.GIA_QUERYRATE) * (Math.log10(this.getComponent().getCapacity()) + 1));
				return (long) (1000000 *tempDelay);
	}
	
}
