package de.tud.kom.p2psim.impl.overlay.gnutella;

import java.util.LinkedList;
import java.util.List;

import de.tud.kom.p2psim.api.overlay.OverlayNode;
import de.tud.kom.p2psim.api.transport.TransInfo;
import de.tud.kom.p2psim.impl.overlay.BootstrapManager;

public class GnutellaBootstrapManager implements BootstrapManager {

	private List<GnutellaOverlayNode> activeNodes = new LinkedList<GnutellaOverlayNode>();
	private List<GnutellaOverlayNode> activePeer = new LinkedList<GnutellaOverlayNode>();
	private static GnutellaBootstrapManager singletonInstance;
	
	public static GnutellaBootstrapManager getInstance() {
		if(singletonInstance == null) {
			singletonInstance = new GnutellaBootstrapManager();
		}
		return singletonInstance;
	}
	
	public List<TransInfo> getBootstrapInfo() {
		List<TransInfo> bootstrapInfo = new LinkedList<TransInfo>();
		for (GnutellaOverlayNode activeNode : activeNodes) {
			bootstrapInfo.add(activeNode.getTransLayer().getLocalTransInfo(activeNode.getPort()));
		}
		return bootstrapInfo;
	}

	public void registerNode(OverlayNode node) {
		activeNodes.add((GnutellaOverlayNode) node);
	}

	public void unregisterNode(OverlayNode node) {
		activeNodes.remove(node);
	}
	
	public int getSize(){
		return activePeer.size();
	}
	
	public void registerPeer(OverlayNode node){
		if (!activePeer.contains(node)){
			activePeer.add((GnutellaOverlayNode) node);
		}
	}
	
	public void unregisterPeer(OverlayNode node){
		if(activePeer.contains(node)){
			activePeer.remove(node);
		}
	}
}
