package de.tud.kom.p2psim.impl.overlay.gnutella;

import java.math.BigInteger;

import de.tud.kom.p2psim.impl.simengine.Simulator;

public class GnutellaConfiguration {
	public final static int GNUTELLA_PING_MAX_TTL = 3;
	public final static int GNUTELLA_QUERY_MAX_TTL = 5;
	public final static double RELATIVE_CONNECT_SLOTS = 0.2;
	public final static int QUERY_KEY_MASK = 7;
	
	private static final int TIME_BITS_IGNORE = 6;
	private static final int TIME_BITS = 30;
	private static final int ID_BITS = 11;
	
	public static BigInteger generateDescriptor(BigInteger id) {
		
		BigInteger rand = BigInteger.valueOf(Simulator.getRandom().nextLong());
		BigInteger time = BigInteger.valueOf(Simulator.getCurrentTime()).divide(BigInteger.valueOf(2).pow(TIME_BITS_IGNORE));
		
		BigInteger timeMultiplicator = BigInteger.valueOf(2).pow(TIME_BITS);
		
		// mask time
		time = time.and(BigInteger.valueOf(2).pow(TIME_BITS).subtract(BigInteger.valueOf(1)));
		// mask id and shift
		id = id.and(BigInteger.valueOf(2).pow(ID_BITS).subtract(BigInteger.valueOf(1))).shiftLeft(TIME_BITS);
		// mask rand
		rand = rand.andNot(BigInteger.valueOf(2).pow(TIME_BITS + ID_BITS).subtract(BigInteger.valueOf(1)));
		
		return time.add(id).add(rand);
	}
}
