package de.tud.kom.p2psim.impl.overlay.gnutella;

import java.math.BigInteger;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.transport.TransInfo;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public class GnutellaOverlayContact implements OverlayContact<GnutellaOverlayID>, Comparable<GnutellaOverlayContact> {

	private GnutellaOverlayID overlayID;
	private TransInfo transInfo;
	
	private long timeActivated;
	private long lastRefresh;

	// TODO gescheites Ranking
	
	public GnutellaOverlayContact(GnutellaOverlayID overlayID, TransInfo transInfo) {
		this.overlayID = overlayID;
		this.transInfo = transInfo;
	}
	
	public GnutellaOverlayContact(OverlayContact<GnutellaOverlayID> contact) {
		this.overlayID = contact.getOverlayID();
		this.transInfo = contact.getTransInfo();
	}

	public GnutellaOverlayID getOverlayID() {
		return this.overlayID;
	}

	public TransInfo getTransInfo() {
		return this.transInfo;
	}
	
	public int hashCode() {
		return this.overlayID.hashCode();
	}

	public int compareTo(GnutellaOverlayContact contact) {
		return this.getOverlayID().compareTo(contact.getOverlayID());
	}

	public boolean equals(Object o) {
		if (o instanceof GnutellaOverlayContact) {
			GnutellaOverlayContact contact = (GnutellaOverlayContact) o;
			return this.overlayID.equals(contact.getOverlayID());
		}
		return false;
	}
	
	public String toString() {
		return this.overlayID.toString();
	}
		
	public void reset() {
		this.timeActivated = Simulator.getCurrentTime();
	}
	
	public double getRank() {
		return Double.MAX_VALUE / (Simulator.getCurrentTime() - this.timeActivated);
	}

	public long getLastRefresh() {
		return lastRefresh;
	}

	public void refresh() {
		this.lastRefresh = Simulator.getCurrentTime();
	}
	
}
