package de.tud.kom.p2psim.impl.overlay.gnutella;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.common.Component;
import de.tud.kom.p2psim.api.common.ComponentFactory;
import de.tud.kom.p2psim.api.common.Host;

public class GnutellaOverlayNodeFactory implements ComponentFactory {

	private final static short port = 123;
	private static long id = 0;
	
	private int numConn;
	private long delayAcceptConnection;
	private long refresh;
	private long contactTimeout;
	private long descriptorTimeout;
	
	public Component createComponent(Host host) {
		return new GnutellaOverlayNode(host.getTransLayer(), newGnutellaOverlayID(), this.numConn, this.delayAcceptConnection, this.refresh, this.contactTimeout, this.descriptorTimeout, port);
	}

	public GnutellaOverlayID newGnutellaOverlayID() {
		this.id += 1;
		System.out.println(new GnutellaOverlayID(BigInteger.valueOf(this.id)));
		return new GnutellaOverlayID(BigInteger.valueOf(this.id));
	}
	
	public void setNumConn(int numConn) {
		this.numConn = numConn;
	}

	public void setDelayAcceptConnection(long delayAcceptConnection) {
		this.delayAcceptConnection = delayAcceptConnection;
	}

	public void setRefresh(long refresh) {
		this.refresh = refresh;
	}

	public void setContactTimeout(long contactTimeout) {
		this.contactTimeout = contactTimeout;
	}
	
	public void setDescriptorTimeout(long descriptorTimeout) {
		this.descriptorTimeout = descriptorTimeout;
	}
}
