package de.tud.kom.p2psim.impl.overlay.gnutella.filesharing;

import java.util.HashMap;
import java.util.Map;

import de.tud.kom.p2psim.api.overlay.OverlayKey;
import de.tud.kom.p2psim.api.storage.Document;
import de.tud.kom.p2psim.impl.util.stat.distributions.zipf.ZipfConfigurer;
import de.tud.kom.p2psim.impl.util.stat.distributions.zipf.ZipfDistribution;

public class FileFactory {

	private ZipfDistribution distribution = new ZipfDistribution();
	private static FileFactory singletonInstance;
	private Map<Integer, FilesharingDocument> files = new HashMap<Integer, FilesharingDocument>();

	public static FileFactory getInstance() {
		if (singletonInstance == null) {
			singletonInstance = new FileFactory();
		}
		return singletonInstance;
	}
	
	public FileFactory() {
		distribution.config(new ZipfConfigurer());
	}
	
	public FilesharingDocument getFile(Integer rank) {
		if(!files.containsKey(rank)) {
			files.put(rank, new FilesharingDocument(rank));
		}
		return files.get(rank);
	}
	
	public FilesharingDocument getFile() {
		Integer rank = distribution.returnRank();
		return getFile(rank);
	}
	
	public FilesharingKey getKey(Integer rank) {
		return (FilesharingKey) this.getFile(rank).getKey();
	}
	
	public FilesharingKey getKey() {
		return (FilesharingKey) this.getFile().getKey();
	}
}
