package de.tud.kom.p2psim.impl.overlay.gnutella.messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public abstract class BaseMessage extends AbstractOverlayMessage<GnutellaOverlayID> {

	private int ttl;
	private int hops;
	private BigInteger descriptor;
	private final static long GNUTELLA_BASE_MESSAGE_SIZE = 23;
	
	public BaseMessage(GnutellaOverlayID sender, GnutellaOverlayID receiver, int ttl, int hops, BigInteger descriptor) {
		super(sender, receiver);
		this.ttl = ttl;
		this.hops = hops;
		this.descriptor = descriptor;
	}
	
	public Message getPayload() {
		return this;
	}
	
	public Integer getTTL() {
		return ttl;
	}
	
	public Integer getHops() {
		return hops;
	}
	
	public BigInteger getDescriptor() {
		return descriptor;
	}

	public long getSize() {
		return GNUTELLA_BASE_MESSAGE_SIZE;
	}

}
