package de.tud.kom.p2psim.impl.overlay.gnutella.messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;

public class ConnectMessage extends AbstractOverlayMessage<GnutellaOverlayID> {

	private final static long GNUTELLA_CONNECT_MESSAGE_SIZE = 23;
	private OverlayContact<GnutellaOverlayID> contact;
	
	public ConnectMessage(GnutellaOverlayID sender, GnutellaOverlayID receiver, OverlayContact<GnutellaOverlayID> contact) {
		super(sender, receiver);
		this.contact = contact;
	}

	public Message getPayload() {
		return this;
	}
	
	public OverlayContact<GnutellaOverlayID> getContact() {
		return contact;
	}

	public long getSize() {
		return GNUTELLA_CONNECT_MESSAGE_SIZE;
	}
	
}
