package de.tud.kom.p2psim.impl.overlay.gnutella.messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.overlay.OverlayID;
import de.tud.kom.p2psim.api.transport.TransInfo;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;

public class PongMessage extends BaseMessage {

	private static final long GNUTELLA_PONG_MESSAGE_SIZE = 14;
	private OverlayContact<GnutellaOverlayID> contact;
	
	public PongMessage(GnutellaOverlayID sender, GnutellaOverlayID receiver, int ttl, int hops, BigInteger descriptor, OverlayContact<GnutellaOverlayID> contact) {
		super(sender, receiver, ttl, hops, descriptor);
		this.contact = contact;
	}

	public OverlayContact<GnutellaOverlayID> getContact() {
		return contact;
	}
	
	public long getSize() {
		return super.getSize() + GNUTELLA_PONG_MESSAGE_SIZE;
	}
}
