package de.tud.kom.p2psim.impl.overlay.gnutella.messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella.filesharing.FilesharingKey;

public class PushMessage extends BaseMessage {

	private static final long GNUTELLA_PUSH_MESSAGE_SIZE = 9999;
	private GnutellaOverlayID pushTarget;
	private FilesharingKey key;
	// TODO Nachrichtengröße
	private OverlayContact<GnutellaOverlayID> pushInitiator;

	public PushMessage(GnutellaOverlayID sender, GnutellaOverlayID receiver, int ttl, int hops, BigInteger descriptor, OverlayContact<GnutellaOverlayID> pushInitiator, GnutellaOverlayID pushTarget, FilesharingKey key) {
		super(sender, receiver, ttl, hops, descriptor);
		this.pushInitiator = pushInitiator;
		this.pushTarget = pushTarget;
		this.key = key;
	}
	
	public OverlayContact<GnutellaOverlayID> getPushSender() {
		return this.pushInitiator;
	}
	
	public GnutellaOverlayID getPushReceiver() {
		return this.pushTarget;
	}
	
	public FilesharingKey getKey() {
		return this.key;
	}
	
	public long getSize() {
		return super.getSize() + GNUTELLA_PUSH_MESSAGE_SIZE;
	}


}
