package de.tud.kom.p2psim.impl.overlay.gnutella.messages;

import java.math.BigInteger;
import java.util.List;
import java.util.Set;

import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella.filesharing.FilesharingKey;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public class QueryHitMessage extends BaseMessage {

	private List<FilesharingKey> keys;
	private final static long QUERY_HIT_MESSAGE_SIZE = 18;
	// TODO Dateibeschreibung
	private OverlayContact<GnutellaOverlayID> contact;
	private long searchStringSize;
	
	public QueryHitMessage(GnutellaOverlayID sender, GnutellaOverlayID receiver, int ttl, int hops, BigInteger descriptor, OverlayContact<GnutellaOverlayID> contact, List<FilesharingKey> keys) {
		super(sender, receiver, ttl, hops, descriptor);
		this.contact = contact;
		this.keys = keys;
		searchStringSize = (long) (Simulator.getRandom().nextDouble() * 40);
	}

	public OverlayContact<GnutellaOverlayID> getContact() {
		return contact;
	}
	
	public List<FilesharingKey> getKeys() {
		return keys;
	}
	
	public long getSize() {
		// TODO low priority: Korrekte Nachrichtengröße
		return super.getSize() + QUERY_HIT_MESSAGE_SIZE + searchStringSize;
	}
}
