package de.tud.kom.p2psim.impl.overlay.gnutella.messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella.filesharing.FilesharingKey;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public class QueryMessage extends BaseMessage {
	
	private static final long GNUTELLA_QUERY_MESSAGE_SIZE = 3;
//	private Integer minimumSpeed;
	private long searchStringSize;
	private FilesharingKey key;
	// TODO Seed für zufällig Falsch-Ergebnisse
	
	public QueryMessage(GnutellaOverlayID sender, GnutellaOverlayID receiver, int ttl, int hops, BigInteger descriptor, FilesharingKey key) {
		super(sender, receiver, ttl, hops, descriptor);
		searchStringSize = (long) (Simulator.getRandom().nextDouble() * 40);
		this.key = key;
	}

	public FilesharingKey getKey() {
		return this.key;
	}
	
	public long getSize() {
		return super.getSize() + GNUTELLA_QUERY_MESSAGE_SIZE + searchStringSize;
	}
}
