package de.tud.kom.p2psim.impl.overlay.gnutella.operations;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.transport.TransInfo;
import de.tud.kom.p2psim.api.transport.TransProtocol;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayNode;
import de.tud.kom.p2psim.impl.overlay.gnutella.messages.ConnectMessage;

public class ConnectOperation extends AbstractOperation<GnutellaOverlayNode, Object> {

	private GnutellaOverlayNode node;
	private TransInfo connectInfo;

	public ConnectOperation(GnutellaOverlayNode node, TransInfo connectInfo, OperationCallback<Object> callback) {
		super(node, callback);
		this.connectInfo = connectInfo;
		this.node = node;
	}

	@Override
	protected void execute() {
		GnutellaOverlayContact contact = new GnutellaOverlayContact((GnutellaOverlayID) node.getOverlayID(), node.getTransLayer().getLocalTransInfo(node.getPort()));
		ConnectMessage message = new ConnectMessage((GnutellaOverlayID) this.node.getOverlayID(), null, contact);
		node.getTransLayer().send(message, connectInfo, node.getPort(), TransProtocol.UDP);
	}

	@Override
	public Object getResult() {
		return this;
	}

}
