package de.tud.kom.p2psim.impl.overlay.gnutella.operations;

import java.math.BigInteger;
import java.util.List;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.transport.TransProtocol;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaConfiguration;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayNode;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayRoutingTable;
import de.tud.kom.p2psim.impl.overlay.gnutella.filesharing.FilesharingKey;
import de.tud.kom.p2psim.impl.overlay.gnutella.messages.PushMessage;
import de.tud.kom.p2psim.impl.overlay.gnutella.messages.QueryHitMessage;

public class PushOperation extends BaseOperation {

	private GnutellaOverlayNode node;
	private OverlayContact<GnutellaOverlayID> pushInitiator;
	private GnutellaOverlayID pushTarget = null;
	private FilesharingKey key;

	public PushOperation(GnutellaOverlayNode node, BigInteger descriptor, FilesharingKey key, OperationCallback<Object> callback) {
		super(node, GnutellaConfiguration.GNUTELLA_QUERY_MAX_TTL, GnutellaConfiguration.GNUTELLA_QUERY_MAX_TTL, 0, descriptor, callback);
		this.node = node;
		this.pushInitiator = new GnutellaOverlayContact((GnutellaOverlayID) node.getOverlayID(), node.getTransLayer().getLocalTransInfo(node.getPort()));
		this.key = key;
	}

	public PushOperation(GnutellaOverlayNode node, int ttl, int hops, BigInteger descriptor, OverlayContact<GnutellaOverlayID> pushInitiator, GnutellaOverlayID pushTarget, FilesharingKey key, OperationCallback<Object> callback) {
		super(node, GnutellaConfiguration.GNUTELLA_QUERY_MAX_TTL, ttl, hops, descriptor, callback);
		this.node = node;
		this.pushInitiator = pushInitiator;
		this.pushTarget = pushTarget;
		this.key = key;
	}

	@Override
	protected void execute() {
		if(pushTarget == null) {
			List<OverlayContact<GnutellaOverlayID>> queryResults = node.getQueryResults(descriptor);
			if(queryResults.isEmpty()) {
				this.operationFinished(false);
				return;
			} else {
				this.pushTarget = queryResults.get(0).getOverlayID();
			}
		}
		// TODO Push Operation
		/*
		OverlayContact<GnutellaOverlayID> contactReceiver = ((GnutellaOverlayRoutingTable) getComponent().getRoutingTable()).outgoingPush(this.pushInitiator, this.descriptor);
		PushMessage message = new PushMessage((GnutellaOverlayID) this.getComponent().getOverlayID(), contactReceiver.getOverlayID(), this.ttl, this.hops, this.descriptor, this.pushInitiator, this.pushTarget, this.key);
		this.getComponent().getTransLayer().send(message, contactReceiver.getTransInfo(), this.getComponent().getPort(), TransProtocol.UDP);
		this.operationFinished(true);
		*/
	}

}
