package de.tud.kom.p2psim.impl.overlay.gnutella.operations;

import java.math.BigInteger;
import java.util.List;
import java.util.Set;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.overlay.OverlayContact;
import de.tud.kom.p2psim.api.transport.TransProtocol;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaConfiguration;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayNode;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayRoutingTable;
import de.tud.kom.p2psim.impl.overlay.gnutella.filesharing.FilesharingKey;
import de.tud.kom.p2psim.impl.overlay.gnutella.messages.QueryHitMessage;

public class QueryHitOperation extends BaseOperation {

	private OverlayContact<GnutellaOverlayID> contact;
	private List<FilesharingKey> keys;

	// TODO QueryHitInformationen mitverschicken (gefundene Dateien?)
	public QueryHitOperation(GnutellaOverlayNode component, BigInteger descriptor, OverlayContact<GnutellaOverlayID> contact, List<FilesharingKey> keys, OperationCallback<Object> callback) {
		super(component, GnutellaConfiguration.GNUTELLA_QUERY_MAX_TTL, GnutellaConfiguration.GNUTELLA_QUERY_MAX_TTL, 0, descriptor, callback);
		this.contact = contact;
		this.keys = keys;
	}

	public QueryHitOperation(GnutellaOverlayNode component, int ttl, int hops, BigInteger descriptor, OverlayContact<GnutellaOverlayID> contact, List<FilesharingKey> keys, OperationCallback<Object> callback) {
		super(component, GnutellaConfiguration.GNUTELLA_QUERY_MAX_TTL, ttl, hops, descriptor, callback);
		this.contact = contact;
		this.keys = keys;
	}

	@Override
	protected void execute() {
		OverlayContact<GnutellaOverlayID> contactReceiver = ((GnutellaOverlayRoutingTable) getComponent().getRoutingTable()).outgoingQueryHit(this.descriptor);
		QueryHitMessage message = new QueryHitMessage((GnutellaOverlayID) this.getComponent().getOverlayID(), contactReceiver.getOverlayID(), this.ttl, this.hops, this.descriptor, this.contact, this.keys);
		this.getComponent().getTransLayer().send(message, contactReceiver.getTransInfo(), this.getComponent().getPort(), TransProtocol.UDP);
	}

}
