package de.tud.kom.p2psim.impl.overlay.gnutella.operations;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaApplication;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayNode;

public class ScheduleApplicationOperation extends AbstractOperation<GnutellaApplication, Object>{

	private boolean active = true;
	private long delay;

	public ScheduleApplicationOperation(GnutellaApplication component, long delay, OperationCallback<Object> callback) {
		super(component, callback);
		this.delay = delay;
	}

	@Override
	protected void execute() {
		if(active) {
			this.getComponent().schedule(this);
		}
		if(active) {
			this.scheduleWithDelay(delay);
		}
	}

	@Override
	public Object getResult() {
		return this;
	}
	
	public void start() {
		active = true;
	}
	
	public void stop() {
		active = false;
	}
	
	public void setDelay(long delay) {
		this.delay = delay;
	}
	
}
