package de.tud.kom.p2psim.impl.overlay.gnutella.operations;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.common.SupportOperations;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaApplication;
import de.tud.kom.p2psim.impl.overlay.gnutella.GnutellaOverlayNode;

public class ScheduleStateOperation extends AbstractOperation<GnutellaOverlayNode, Object> {

	private boolean active = true;
	private long delay;

	public ScheduleStateOperation(GnutellaOverlayNode node, long delay, OperationCallback<Object> callback) {
		super(node, callback);
		this.delay = delay;
	}

	@Override
	protected void execute() {
		if(active) {
			this.scheduleWithDelay(delay);
		}
	}

	public GnutellaOverlayNode getNode() {
		return super.getComponent();
	}
	
	@Override
	public Object getResult() {
		return this;
	}

	public void start() {
		active = true;
	}
	
	public void stop() {
		active = false;
	}
	
	public void setDelay(long delay) {
		this.delay = delay;
	}

}
