package de.tud.kom.p2psim.impl.overlay.gnutella06;

import java.math.BigInteger;

import de.tud.kom.p2psim.impl.simengine.Simulator;

public class Gnutella06Configuration {

	public static final int GNUTELLA06_SUPERPEERPERCENTAGE = 20;
	public static final int GNUTELLA06_PING_MAX_TTL = 3;
	public static final int GNUTELLA06_QUERY_MAX_TTL = 5;
	public static final int GNUTELLA06_MAXLEAFCONTACTS = 12;
	public static final int GNUTELLA06_MAXSUPERPEERCONTACTS = 12;
	public static final int GNUTELLA06_MAXCONTACTSFORLEAF = 3;
	public static final int GNUTELLA06_SCHEDULECONNECT = 10000000;
	public static final int GNUTELLA06_SCHEDULERECONNECT = 2000000;
	public static final int GNUTELLA06_TIMEOUT = 8000000;
	public static final int GNUTELLA06_SCHEDULEDCHECKNEIGHBORS = 6000000;
	public static final int GNUTELLA06_SCHEDULEDLEAVE = 2000000;
	public static final int GNUTELLA06_QUERYRATE = 60000000;
	public static final long GNUTELLA06_SCHEDULEPING = 6000000;
	
	public final static boolean GNUTELLA06_CHURN = false;
	public final static long GNUTELLA06_SESSIONTIMEBENEFACTOR = 600;
	public final static long GNUTELLA06_OFFTIMEBENEFACTOR = 200;
	public final static long GNUTELLA06_SESSIONTIMEPEER = 60;
	public final static long GNUTELLA06_OFFTIMEPEER = 60;
	public final static double GNUTELLA06_CHURNFACTOR = 0.5;
	
	private static final int TIME_BITS_IGNORE = 6;
	private static final int TIME_BITS = 30;
	private static final int ID_BITS = 11;
	
public static BigInteger generateDescriptor(BigInteger id) {
		
		BigInteger rand = BigInteger.valueOf(Simulator.getRandom().nextLong());
		BigInteger time = BigInteger.valueOf(Simulator.getCurrentTime()).divide(BigInteger.valueOf(2).pow(TIME_BITS_IGNORE));
		
		BigInteger timeMultiplicator = BigInteger.valueOf(2).pow(TIME_BITS);
		
		// mask time
		time = time.and(BigInteger.valueOf(2).pow(TIME_BITS).subtract(BigInteger.valueOf(1)));
		// mask id and shift
		id = id.and(BigInteger.valueOf(2).pow(ID_BITS).subtract(BigInteger.valueOf(1))).shiftLeft(TIME_BITS);
		// mask rand
		rand = rand.andNot(BigInteger.valueOf(2).pow(TIME_BITS + ID_BITS).subtract(BigInteger.valueOf(1)));
		
		return time.add(id).add(rand);
	}
}
