package de.tud.kom.p2psim.impl.overlay.gnutella06;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.overlay.OverlayID;

/**
 * @author Jonas Khne
 * @version 3.0, 06.07.2008
 *
 */
public class Gnutella06OverlayID implements OverlayID{
	
	private BigInteger gnutella06ID;
	
	/**
	 * @param gnutella06ID big Integer value of the overlay ID
	 */
	public Gnutella06OverlayID(BigInteger gnutella06ID){
		this.gnutella06ID = gnutella06ID;
	}
	
	/**
	 * @param gnutella06ID Integer value of the overlay ID
	 */
	public Gnutella06OverlayID(int gnutella06ID){
		this.gnutella06ID = BigInteger.valueOf(gnutella06ID);
	}
	
	public byte[] getBytes(){	
		return null;
	}
	
	public Object getUniqueValue(){
		return this.gnutella06ID;
	}
	
	/**
	 * @return the overlay ID
	 */
	public BigInteger getValue(){
		return this.gnutella06ID;
	}
	
	public int compareTo(OverlayID arg0){
		Gnutella06OverlayID m = (Gnutella06OverlayID)arg0;
		return this.gnutella06ID.compareTo(m.getValue());
	}
	
	/**
	 * @param id overlay ID
	 * @return the difference between this overlay ID and id
	 */
	public int getDistance(Gnutella06OverlayID id){
		BigInteger oid = id.getValue();
		return this.gnutella06ID.subtract(oid).abs().intValue();
	}
	
	/**
	 * @param id overlay ID
	 * @return true if o equals this overlay ID
	 */
	public boolean equals(Gnutella06OverlayID id){
		return this.gnutella06ID.compareTo(id.getValue()) == 0;
	}
	
	public String toString() {
		return this.gnutella06ID.toString();
	}
}