package de.tud.kom.p2psim.impl.overlay.gnutella06.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayID;

public class Gnutella06ByeMessage extends AbstractOverlayMessage<Gnutella06OverlayID>{

	private String errorCode;  // Grund fr die Beendigung/Zurcksetzung der Verbindung

	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param errorCode reason for the bye message
	 */
	public Gnutella06ByeMessage(Gnutella06OverlayID sender, Gnutella06OverlayID receiver, String errorCode) {
		super(sender, receiver);
		this.errorCode = errorCode;
	}

	/**
	 * @return error code
	 */
	public String getErrorCode(){
		return errorCode;
	}
	
	public Message getPayload() {
		return this;
	}

	public long getSize() {
		// TODO Size festlegen
		return 0;
	}

}
