package de.tud.kom.p2psim.impl.overlay.gnutella06.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayID;

public class Gnutella06ConnectAcceptMessage extends AbstractOverlayMessage<Gnutella06OverlayID>{

	private Gnutella06OverlayContact contact;
	private static long Gnutella06_ConnectAcceptMESSAGE_SIZE;
	private boolean isSuperpeer;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param contact contact info of the sender
	 * @param isSuperpeer true if Sender is a super peer
	 */
	public Gnutella06ConnectAcceptMessage(Gnutella06OverlayID sender, Gnutella06OverlayID receiver, Gnutella06OverlayContact contact, boolean isSuperpeer) {
		super(sender, receiver);
		this.contact = contact;
		this.isSuperpeer = isSuperpeer;
	}

	public Message getPayload() {
		return this;
	}
	
	/**
	 * @return contact info
	 */
	public Gnutella06OverlayContact getContact(){
		return contact;
	}
	
	public boolean getSuperpeer(){
		return isSuperpeer;
	}

	public long getSize() {
		return Gnutella06_ConnectAcceptMESSAGE_SIZE;
	}
	
}
