package de.tud.kom.p2psim.impl.overlay.gnutella06.Messages;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayID;

public class Gnutella06ConnectMessage extends AbstractOverlayMessage<Gnutella06OverlayID> {

	private final static long GNUTELLA06_CONNECT_MESSAGE_SIZE = 22;
	private Gnutella06OverlayContact contact;
	private boolean isSuperpeer;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param contact contact info of the sender
	 * @param superPeer informs the receiver if the sender is a super peer
	 */
	public Gnutella06ConnectMessage(Gnutella06OverlayID sender, Gnutella06OverlayID receiver, Gnutella06OverlayContact contact, boolean isSuperpeer) {
		super(sender, receiver);
		this.contact = contact;
		this.isSuperpeer = isSuperpeer;
	}

	public Message getPayload() {
		return this;
	}
	
	/**
	 * @return contact info
	 */
	public Gnutella06OverlayContact getContact() {
		return contact;
	}
	
	public boolean getSuperPeer(){
		return isSuperpeer;
	}

	public long getSize() {
		return GNUTELLA06_CONNECT_MESSAGE_SIZE;
	}
}
		
