package de.tud.kom.p2psim.impl.overlay.gnutella06.Messages;

import java.util.List;

import de.tud.kom.p2psim.api.common.Message;
import de.tud.kom.p2psim.impl.overlay.AbstractOverlayMessage;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayContact;

public class Gnutella06ConnectionDeniedMessage  extends AbstractOverlayMessage<Gnutella06OverlayID>{

	private String errorCode;   // Grund fr die Beendigung/Zurcksetzung der Verbindung
	private boolean switchToLeaf;
	private List<Gnutella06OverlayContact> superpeers;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param errorCode reason for the denied connection
	 */
	public Gnutella06ConnectionDeniedMessage(Gnutella06OverlayID sender, Gnutella06OverlayID receiver, String errorCode, boolean switchToLeaf, List<Gnutella06OverlayContact> superpeers) {
		super(sender, receiver);
		this.errorCode = errorCode;
		this.switchToLeaf = switchToLeaf;
		this.superpeers = superpeers;
	}

	/**
	 * @return error code
	 */
	public String getErrorCode(){
		return errorCode;
	}
	
	public boolean getSwitchToLeaf(){
		return switchToLeaf;
	}
	
	public List<Gnutella06OverlayContact> getSuperpeers(){
		return superpeers;
	}
	
	public Message getPayload() {
		return this;
	}

	public long getSize() {
		//TODO: Size festlegen
		return 0;
	}

}
