package de.tud.kom.p2psim.impl.overlay.gnutella06.Messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayID;

public class Gnutella06PongMessage extends BaseMessage{
	
	private static final long Gnutella06_PONG_MESSAGE_SIZE = 14;
	private Gnutella06OverlayContact contact;
	private boolean isSuperpeer;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param ttl time to live of the message
	 * @param hops hop count for the message
	 * @param descriptor message ID
	 * @param contact contact info of sender
	 * @param isSuperpeer true if sender of pong is super peer
	 */
	public Gnutella06PongMessage(Gnutella06OverlayID sender, Gnutella06OverlayID receiver, int ttl, int hops, BigInteger descriptor, Gnutella06OverlayContact contact, boolean isSuperpeer) {
		super(sender, receiver, ttl, hops, descriptor);
		this.contact = contact;
		this.isSuperpeer = isSuperpeer;
	}
	
	/**
	 * @return contact info
	 */
	public Gnutella06OverlayContact getContact() {
		return contact;
	}
	
	public boolean getSuperpeer(){
		return isSuperpeer;
	}
	 
	public long getSize(){
		return super.getSize() + Gnutella06_PONG_MESSAGE_SIZE;
	}

}
