package de.tud.kom.p2psim.impl.overlay.gnutella06.Messages;

import java.math.BigInteger;

import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayID;

public class Gnutella06QueryHitMessage extends BaseMessage {

	private Gnutella06OverlayContact contact;
	
	/**
	 * @param sender overlay ID of the sender
	 * @param receiver overlay ID of the receiver
	 * @param ttl time to live of the message
	 * @param hops hop count for the message
	 * @param descriptor message ID
	 * @param contact contact info of sender
	 */
	public Gnutella06QueryHitMessage(Gnutella06OverlayID sender, Gnutella06OverlayID receiver, int ttl, int hops, BigInteger descriptor, Gnutella06OverlayContact contact) {
		super(sender, receiver, ttl, hops, descriptor);
		this.contact = contact;
	}

	/**
	 * @return contact info
	 */
	public Gnutella06OverlayContact getContact() {
		return contact;
	}
	
	public long getSize() {
		return super.getSize();
	}
	
}
