package de.tud.kom.p2psim.impl.overlay.gnutella06.Operations;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06Configuration;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayNode;

public abstract class BaseOperation extends AbstractOperation<Gnutella06OverlayNode, Object> {

	protected int ttl;
	protected int hops;
	protected BigInteger descriptor;

	protected BaseOperation(Gnutella06OverlayNode component, int maxTTL, int ttl, int hops, BigInteger descriptor, OperationCallback<Object> callback) {
		super(component, callback);
		this.ttl = ttl-1;
		this.hops = hops+1;
		this.descriptor = descriptor;
		
		if(this.descriptor == null) {
			this.descriptor = Gnutella06Configuration.generateDescriptor((BigInteger) component.getOverlayID().getUniqueValue());
		}

		// don't process if negative hop count
		if(this.hops < 0) {
			this.hops = 0;
			this.ttl = 0;
		}
		
		// decrease ttl, if higher than maximal ttl
		if(this.hops + this.ttl > maxTTL) {
			this.ttl = maxTTL - this.hops;
		}
	}
	
	/**
	 * @return message ID
	 */
	public BigInteger getDescriptor() {
		return this.descriptor;
	}

	@Override
	public Object getResult() {
		return this;
	}
}
