package de.tud.kom.p2psim.impl.overlay.gnutella06.Operations;

import java.math.BigInteger;
import java.util.LinkedList;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06Configuration;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayNode;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public class Gnutella06CheckNeighborsOperation extends AbstractOperation<Gnutella06OverlayNode, Object> {

	long delay;
	
	/**
	 * @param node initiator of this operation
	 * @param delay interval the massage should be send in
	 * @param callback
	 */
	public Gnutella06CheckNeighborsOperation(Gnutella06OverlayNode node, long delay, OperationCallback<Object> callback){
		super(node, callback);
		this.delay = delay;
	}

	@Override
	protected void execute() {
		if(this.getComponent().isActive()){
			for(Gnutella06OverlayContact contact : this.getComponent().getNodesRoutingTable().allContacts()){
				if(!(this.getComponent().getLastMessageReceived(contact.getOverlayID()) == 0)){
					if(Simulator.getCurrentTime() - this.getComponent().getLastMessageReceived(contact.getOverlayID()) > Gnutella06Configuration.GNUTELLA06_TIMEOUT){
						this.getComponent().getNodesRoutingTable().removeContact(contact.getOverlayID());
						this.getComponent().getNodesRoutingTable().removeInactiveContact(contact);
						this.getComponent().connect();
						
					}
				}
			}
			this.scheduleWithDelay(delay);
			operationFinished(true);
		}
	}

	@Override
	public Object getResult() {
		return this;
	}
}

