package de.tud.kom.p2psim.impl.overlay.gnutella06.Operations;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.api.transport.TransInfo;
import de.tud.kom.p2psim.api.transport.TransProtocol;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayID;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayNode;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Messages.Gnutella06ConnectMessage;

public class Gnutella06ConnectOperation extends AbstractOperation<Gnutella06OverlayNode, Object> {

	private Gnutella06OverlayNode node;
	private TransInfo connectInfo;
	private boolean isSuperpeer;
	
	/**
	 * @param node initiator of this operation
	 * @param connectInfo transport info
	 * @param numberOfNeighbors number of neighbors
	 * @param callback
	 */
	public Gnutella06ConnectOperation(Gnutella06OverlayNode node, TransInfo connectInfo, boolean isSuperpeer, OperationCallback<Object> callback) {
		super(node, callback);
		this.connectInfo = connectInfo;
		this.node = node;
		this.isSuperpeer = isSuperpeer;
	}

	@Override
	protected void execute() {
		Gnutella06ConnectMessage message = new Gnutella06ConnectMessage((Gnutella06OverlayID) this.node.getOverlayID(), null, this.getComponent().getOwnContactData(), isSuperpeer);
		node.getTransLayer().send(message, connectInfo, node.getPort(), TransProtocol.UDP);
		
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}

}

