package de.tud.kom.p2psim.impl.overlay.gnutella06.Operations;

import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06Configuration;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayNode;

public class Gnutella06ScheduleConnectOperation extends AbstractOperation<Gnutella06OverlayNode, Object>{
	
	long delay;
	
	/**
	 * @param node initiator of this operation
	 * @param callback
	 */
	public Gnutella06ScheduleConnectOperation(Gnutella06OverlayNode node, OperationCallback<Object> callback){
		super(node, callback);
	}

	@Override
	protected void execute() {
		
		if(this.getComponent().isActive()){
			delay = Gnutella06Configuration.GNUTELLA06_SCHEDULECONNECT;
			this.getComponent().connect();
			if(this.getComponent().isSuperpeer()){
				if(this.getComponent().getNodesRoutingTable().activeLeafContacts().size()>= (Gnutella06Configuration.GNUTELLA06_MAXLEAFCONTACTS/2)
						&& this.getComponent().getNodesRoutingTable().allContacts().size()>= (Gnutella06Configuration.GNUTELLA06_MAXSUPERPEERCONTACTS/2)){
					delay = delay*2;
				}
					
			}
			else if(this.getComponent().getNodesRoutingTable().allContacts().size()>= (Gnutella06Configuration.GNUTELLA06_MAXCONTACTSFORLEAF/2)){
				delay = delay*2;
			}
			this.scheduleWithDelay(delay);
		}
		
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}
	
}

