package de.tud.kom.p2psim.impl.overlay.gnutella06.Operations;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06Configuration;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayNode;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public class Gnutella06ScheduleJoinOperation extends AbstractOperation<Gnutella06OverlayNode, Object>{

	int userType;
	/**
	 * @param node (initiator of this Operation)
	 * @param callback
	 */
	public Gnutella06ScheduleJoinOperation(Gnutella06OverlayNode node, int UserType, OperationCallback<Object> callback){
		super(node, callback);
		this.userType = userType;
	}

	@Override
	protected void execute() {
		this.getComponent().setActive();
		this.getComponent().join();	

		Gnutella06ScheduleLeaveOperation leave = new Gnutella06ScheduleLeaveOperation(this.getComponent(), userType, new OperationCallback<Object>(){
			public void calledOperationFailed(Operation<Object> op) {
				//
			}
			public void calledOperationSucceeded(Operation<Object> op) {
				//
			}});
		int random = 30 - Simulator.getRandom().nextInt(60); 
		if(userType == 0){
			leave.scheduleWithDelay((Gnutella06Configuration.GNUTELLA06_SESSIONTIMEBENEFACTOR + random)*Simulator.SECOND_UNIT);
		}
		else if(userType == 1){
			leave.scheduleWithDelay((Gnutella06Configuration.GNUTELLA06_SESSIONTIMEPEER + random)*Simulator.SECOND_UNIT);
		}
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}
}
