package de.tud.kom.p2psim.impl.overlay.gnutella06.Operations;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06Configuration;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayContact;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayNode;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

public class Gnutella06SchedulePingOperation extends AbstractOperation<Gnutella06OverlayNode, Object> {
	
	long delay;
	
	protected final static Logger log = SimLogger.getLogger(Gnutella06SchedulePingOperation.class);

	/**
	 * @param node initiator of this operation
	 * @param delay interval this message should be send in
	 * @param callback
	 */
	public Gnutella06SchedulePingOperation(Gnutella06OverlayNode node, long delay, OperationCallback<Object> callback) {
		super(node, callback);
		this.delay = delay;
	}

	@Override
	protected void execute() {
		
		if(this.getComponent().isActive()){
			if (this.getComponent().getNodesRoutingTable().inactiveContacts().size() < 35){
				for(Gnutella06OverlayContact receiver : this.getComponent().getNodesRoutingTable().allContacts()){
					Gnutella06PingOperation ping = new Gnutella06PingOperation(this.getComponent(), receiver, new OperationCallback<Object>(){
							public void calledOperationFailed(Operation<Object> op) {
								//
							}
							public void calledOperationSucceeded(Operation<Object> op) {
								//
							}});
					ping.scheduleImmediately();
				}
				for(Gnutella06OverlayContact receiver : this.getComponent().getNodesRoutingTable().activeLeafContacts()){
					Gnutella06PingOperation ping = new Gnutella06PingOperation(this.getComponent(), receiver, new OperationCallback<Object>(){
							public void calledOperationFailed(Operation<Object> op) {
								//
							}
							public void calledOperationSucceeded(Operation<Object> op) {
								//
							}});
					ping.scheduleImmediately();
				}
			}	 
			else {
				for(Gnutella06OverlayContact receiver : this.getComponent().getNodesRoutingTable().allContacts()){
					Gnutella06PingOperation ping = new Gnutella06PingOperation(this.getComponent(), receiver, 1, 0, null, new OperationCallback<Object>(){
							public void calledOperationFailed(Operation<Object> op) {
								//
							}
							public void calledOperationSucceeded(Operation<Object> op) {
								//
							}});
					ping.scheduleImmediately();
				}
				for(Gnutella06OverlayContact receiver : this.getComponent().getNodesRoutingTable().activeLeafContacts()){
					Gnutella06PingOperation ping = new Gnutella06PingOperation(this.getComponent(), receiver, 1, 0, null, new OperationCallback<Object>(){
							public void calledOperationFailed(Operation<Object> op) {
								//
							}
							public void calledOperationSucceeded(Operation<Object> op) {
								//
							}});
					ping.scheduleImmediately();
				}
			}			
		}
		if(this.getComponent().isActive()){
			this.scheduleWithDelay(delay);
		}
		operationFinished(true);
	}

	@Override
	public Object getResult() {
		return this;
	}
}

