package de.tud.kom.p2psim.impl.overlay.gnutella06.Operations;

import org.apache.log4j.Logger;

import de.tud.kom.p2psim.api.common.Operation;
import de.tud.kom.p2psim.api.common.OperationCallback;
import de.tud.kom.p2psim.impl.common.AbstractOperation;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06Configuration;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06FileFactory;
import de.tud.kom.p2psim.impl.overlay.gnutella06.Gnutella06OverlayNode;
import de.tud.kom.p2psim.impl.simengine.Simulator;
import de.tud.kom.p2psim.impl.util.logging.SimLogger;

public class Gnutella06ScheduleQueryOperation extends AbstractOperation<Gnutella06OverlayNode, Object>{

	protected final static Logger log = SimLogger.getLogger(Gnutella06ScheduleQueryOperation.class);
	private long delay;
	
	/**
	 * @param node (initiator of this operation)
	 * @param callback
	 */
	public Gnutella06ScheduleQueryOperation(Gnutella06OverlayNode node, OperationCallback<Object> callback){
		super(node, callback);
	}

	@Override
	protected void execute() {
		int file = 0;
		int key = 0;
		for(int i = 0; i < 5; i++){
			key = Gnutella06FileFactory.getInstance().getZipf().returnRank();
			file = key;
			if(Gnutella06FileFactory.getInstance().getFileSharingKeys().contains(file)){
				i = 5;
			}
		}
//		FileSharingKey file = FileFactory.getInstance().getFileKey(Simulator.getRandom().nextInt(FileFactory.getInstance().getNumberOfFiles()));
		if(this.getComponent().isActive()){	
			if(!this.getComponent().getDocuments().contains(file)){
				//System.out.println("query for " +file);
				Gnutella06QueryOperation query = new Gnutella06QueryOperation(this.getComponent(), file, new OperationCallback<Object>(){
						public void calledOperationFailed(Operation<Object> op) {
							//
						}
						public void calledOperationSucceeded(Operation<Object> op) {
							//
						}});			
				query.scheduleImmediately();
			}
//			else this.getComponent().sendQuery();
//			this.scheduleImmediately();
			delay = Gnutella06Configuration.GNUTELLA06_QUERYRATE - Simulator.getRandom().nextInt(30) * 1000000;
			this.scheduleWithDelay(delay);
		}
		
		operationFinished(true);
	}
	
	

	@Override
	public Object getResult() {
		return this;
	}
	
}
