package de.tud.kom.p2psim.impl.util.gui.gnp;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import de.tud.kom.p2psim.impl.network.gnp.topology.HostMap;

public class Frontend extends JFrame implements ActionListener {

	private HostMap map = new HostMap();

	PanelSkitter panelImportSkitter = new PanelSkitter(map, this);
	PanelGeolocation panelLocateSkitter = new PanelGeolocation(map, this);
	PanelGNP panelCalculateGNP = new PanelGNP(map, this);
	PanelPingER panelImportPingER = new PanelPingER(map, this);
	PanelHostsAndGroups panelGroups = new PanelHostsAndGroups(map, this);
//	PanelSimulator panelSimulation = new PanelSimulator(map, this);

//	JMenuItem itemOpenMap = new JMenuItem("Open...");
//	JMenuItem itemCloseMap = new JMenuItem("Close");
	JMenuItem itemSaveMap = new JMenuItem("Export to XML Simulator...");
	JMenuItem itemQuit = new JMenuItem("Quit");

	public Frontend() {
		super();

		JMenuBar menuBar = new JMenuBar();
		JMenu menuFile = new JMenu("File");
//		itemOpenMap.addActionListener(this);
//		itemCloseMap.addActionListener(this);
		itemQuit.addActionListener(this);
		itemSaveMap.addActionListener(this);
//		menuFile.add(itemOpenMap);
//		menuFile.add(itemCloseMap);
		menuFile.add(itemSaveMap);
		menuFile.add(itemQuit);
		menuBar.add(menuFile);
		setJMenuBar(menuBar);

		JTabbedPane tab = new JTabbedPane();
		tab.addTab("Skitter", panelImportSkitter);
		tab.addTab("Geolocation", panelLocateSkitter);
		tab.addTab("GNP", panelCalculateGNP);
		tab.addTab("PingER", panelImportPingER);
		tab.addTab("Hosts & Groups", panelGroups);
//		tab.addTab("Simulator", panelSimulation);
//		tab.addTab("Result Analysis", panelAnalysis);
		this.getContentPane().add(tab);
		pack();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == itemSaveMap) {
			actionSaveMap();
		} else if (e.getSource() == itemQuit) {
			System.exit(0);
		}
	}

	private void actionSaveMap() {
		JFileChooser fileChooser = new JFileChooser();
		int status = fileChooser.showSaveDialog(this);
		if (status == JFileChooser.APPROVE_OPTION) {
			this.map.exportToXml(fileChooser.getSelectedFile());
		}
	}

	public void updatePanelHostsChanged() {
		this.panelCalculateGNP.updatePanel();
		this.panelImportSkitter.updatePanel();
		this.panelImportPingER.updatePanel();
		this.panelLocateSkitter.updatePanel();
		this.panelGroups.updatePanel();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Frontend frontend = new Frontend();
		frontend.setSize(java.awt.Toolkit.getDefaultToolkit().getScreenSize());
		frontend.setVisible(true);
	}

}
