package de.tud.kom.p2psim.impl.util.gui.gnp;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

import de.tud.kom.p2psim.SimulatorRunner;
import de.tud.kom.p2psim.impl.simengine.Simulator;

public class PanelRunSimulation extends JPanel implements ActionListener {

	String configFile;

	private JProgressBar progressBar = new JProgressBar();
	private JLabel progressLabel = new JLabel();
	private JButton runCalculation = new JButton("Start");

	public PanelRunSimulation(String configFile) {
		this.configFile = configFile;
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(progressBar);
		add(progressLabel);
		add(runCalculation);
		runCalculation.addActionListener(this);
		progressBar.setMinimum(0);
	}

	private class SimulationThread extends Thread {

		String configFile;

		public SimulationThread(String configFile) {
			this.configFile = configFile;
		}

		@Override
		public void run() {
			Timer timer = new Timer();
			timer.schedule(new ProgressUpdate(), 1000, 1000);
			String[] args = { configFile };
			SimulatorRunner.main(args);
			timer.cancel();
			progressBar.setValue(0);
			runCalculation.setEnabled(true);
		}
	}

	private class ProgressUpdate extends TimerTask {

		@Override
		public void run() {
			//progressBar.setMaximum((int) Simulator.getFinishAt());
			progressBar.setValue((int) Simulator.getCurrentTime());
			progressLabel.setText(Simulator.getSimulatedRealtime());
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == runCalculation) {
			SimulationThread thread = new SimulationThread(configFile);
			thread.start();
			runCalculation.setEnabled(false);
		}
	}
}
