package de.tud.kom.p2psim.impl.util.guirunner.impl;

import java.io.File;

import javax.swing.tree.DefaultMutableTreeNode;

/**
 * A tree node that represents a directory.
 * 
 * @author Leo Nobach
 * @version 3.0, 25.11.2008
 *
 */
public class ConfigDirTreeNode extends DefaultMutableTreeNode {

	public ConfigDirTreeNode(File configDir) {
		super(configDir.getName());
	}
	
	/**
	 * A tree node that is the root of all nodes
	 * 
	 * @author Leo Nobach
	 * @version 3.0, 25.11.2008
	 *
	 */
	public static class Root extends DefaultMutableTreeNode {
		public Root() {
			super("PeerfactSim Configurations");
		}
	}
	
	/**
	 * A tree node that is the root of the last opened files
	 * 
	 * @author Leo Nobach
	 * @version 3.0, 25.11.2008
	 *
	 */
	public static class LastOpenedRoot extends DefaultMutableTreeNode {
		public LastOpenedRoot() {
			super("Recently opened");
		}
	}
	
	/**
	 * A tree node that is the root of all available files
	 * 
	 * @author Leo Nobach
	 * @version 3.0, 25.11.2008
	 *
	 */
	public static class AvailableRoot extends DefaultMutableTreeNode {
		public AvailableRoot() {
			super("Available configs");
		}
	}
}
