package de.tud.kom.p2psim.impl.util.guirunner.impl;

import java.io.File;

import javax.swing.tree.DefaultMutableTreeNode;

/**
 * 
 * A tree node that represents a configuration file
 * 
 * @author Leo Nobach
 * @version 3.0, 25.11.2008
 *
 */
public class ConfigTreeNode extends DefaultMutableTreeNode {

	private File configFile;

	public ConfigTreeNode(File configFile) {
		super(configFile.getName());
		
		this.configFile = configFile;
		
	}
	
	/**
	 * Returns the config file this node is associated to.
	 * @return
	 */
	public File getConfigFile() {
		return configFile;
	}
	
	/**
	 * A node to represent a last-opened entry
	 * 
	 * @author Leo Nobach
	 * @version 3.0, 25.11.2008
	 *
	 */
	public static class LastOpened extends ConfigTreeNode {
		public LastOpened(File configFile) {
			super(configFile);
		}
	}
}
