package de.tud.kom.p2psim.impl.util.guirunner.impl;

import java.io.File;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.MutableTreeNode;

/**
 * 
 * Controls directory browsing and file type checking.
 * 
 * @author Leo Nobach
 * @version 3.0, 25.11.2008
 *
 */
public class FileController {

	/**
	 * Appends all files and dirs in given directory rootDir to rootNode, recursively.
	 * @param rootNode
	 * @param rootDir
	 * @return
	 */
	public static boolean getConfigFiles(DefaultMutableTreeNode rootNode, File rootDir) {
		
		File[] filesArray = rootDir.listFiles();
		Set<File> files = new TreeSet<File>();
		for (int i = 0; i < filesArray.length; i++) files.add(filesArray[i]);
		
		boolean containsAConfig = false;
		
		for(File f : files) {
			
			if (f.isDirectory()) {
				DefaultMutableTreeNode subDir = new ConfigDirTreeNode(f);
				if (getConfigFiles(subDir, f)) {
					containsAConfig = true;
					rootNode.add(subDir);
				}
				
			} else if (fileIsConfig(f)) {
				MutableTreeNode configFile = new ConfigTreeNode(f);
				containsAConfig = true;
				rootNode.add(configFile);
				
			}
		}
		
		return containsAConfig;
	}

	/**
	 * Checks whether the given file is an XML config file or not.
	 * @param f
	 * @return
	 */
	private static boolean fileIsConfig(File f) {
		return f.getName().endsWith(".xml");
	}
	
}
