/**
 * 
 */
package de.tud.kom.p2psim.impl.util.stat.distributions.zipf;

import de.tud.kom.p2psim.impl.util.stat.distributions.DistributionConfigurer;

/**
 * @author Kalman Graffi
 * @version 0.1, 26.09.2007
 * see http://www.alias-i.com/lingpipe/docs/api/com/aliasi/stats/ZipfDistribution.html
 */
public class ZipfConfigurer extends DistributionConfigurer {
	private static final int DEFAULT_MAX_NR_OF_RANKS = 10000;
	private static final double DEFAULT_ZIPF_EXPONENT = 1.0;
	
	
	private int maximum_number_of_ranks;
	private double zipfExponent;
	
	public ZipfConfigurer(int maxNrOfRanks, double zipfExp){
		maximum_number_of_ranks=maxNrOfRanks;
		zipfExponent = zipfExp;
	}
	
	public ZipfConfigurer() {
		maximum_number_of_ranks = DEFAULT_MAX_NR_OF_RANKS;
		zipfExponent = DEFAULT_ZIPF_EXPONENT;
	}
	
	public int getMaxNrOfRanks(){
		return maximum_number_of_ranks;
	}
	public double getZipfExponent(){
		return zipfExponent;
	}
	
	
}
