package de.tud.kom.p2psim.impl.util.time;

import java.io.Serializable;

public class TimeInterval implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2507182065133031420L;

	/**
	 * 1000*60*60*24
	 */
	public static final long dayms = 86400000;
	
	/**
	 * 1000*60*60
	 */
	public static final long hourms = 3600000;
	
	/**
	 * 1000*60
	 */
	public static final long minms = 60000;
	
	/**
	 * 1000
	 */
	public static final long secms = 1000;
	
	
	long milliseconds;
	
	public TimeInterval(long milliseconds) {
		this.milliseconds = milliseconds;
	}
	
	@Override
	public String toString() {
		long days = milliseconds/dayms;
		long daysSub = days*dayms;
		
		long hours = (milliseconds-daysSub)/hourms;
		long hoursSub = daysSub+hours*hourms;
		
		long mins = (milliseconds-days*dayms-hoursSub)/minms;
		long minsSub = hoursSub+mins*minms;
		
		long secs = (milliseconds-minsSub)/secms;
		
		String result = "";
		if (days != 0) result += days + ((days == 1)?" Tag, ":" Tage, ");
		if (hours != 0) result += hours + ((hours == 1)?" Stunde, ":" Stunden, ");
		if (mins != 0) result += mins + ((mins == 1)?" Minute, ":" Minuten, ");
		result += secs + ((secs == 1)?" Sekunde":" Sekunden");
		
		return result;
	}
	
	
}
