package de.tud.kom.p2psim.impl.util.vis;

import java.io.File;
import java.io.IOException;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.model.VisDataModel;

/**
 * Startet die Anwendung im Standalone-Modus, z.B.
 * zum Abspielen von Aufzeichnungen o.Ä.
 * 
 * 
 * See <a href="http://www.student.informatik.tu-darmstadt.de/~l_nobach/docs/howto-visualization.pdf">PeerfactSim.KOM Visualization HOWTO</a>
 * on how to use the visualization.
 * 
 * @author Leo Nobach
 *
 */
public class RunStandalone {

	
	/**
	 * Startet die Anwendung im Standalone-Modus, z.B.
	 * zum Abspielen von Aufzeichnungen o.Ä.
	 * @param args
	 */
	public static void main (String[] args) { 
		Controller.init();
		if (args.length > 0) {
			System.out.println("Lade im Argument übergebene Datei: \"" + args[0] + "\"...");
			try {
				File f = new File(args[0]);
				Controller.loadModelFrontend(VisDataModel.fromFile(f));
				Controller.getModel().setName(f.getName());
			} catch (IOException e) {
				System.out.println("Datei ließ sich nicht laden: " + e.getMessage());
				e.printStackTrace();
			}
		}
	}
	
}
