package de.tud.kom.p2psim.impl.util.vis.analyzer.netPosTransformers;

import de.tud.kom.p2psim.api.network.NetPosition;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.Coords;

/**
 * Interface für konkrete NetPosionenTransformer
 * 
 * @author Julius
 *
 * @param <T> Konkreter Typ der durch den speziellen NetTransformer umwandeln soll (Bspw. SimpleEurclidianPoint)
 */
public interface INetPositionTransformer<T extends NetPosition> {

	/**
	 * @param NetPosition
	 * @return die 2D-Koordinaten nach Umwandlung aus der gegebenen NetPosition 
	 */
	public Coords transform(T netPos);

}