package de.tud.kom.p2psim.impl.util.vis.analyzer.ol.chord;

import java.math.BigInteger;

import de.tud.kom.p2psim.api.overlay.OverlayNode;
import de.tud.kom.p2psim.impl.overlay.dht.chord.ChordNode;
import de.tud.kom.p2psim.impl.util.vis.analyzer.positioners.generic.RingPositioner;

/**
 * Positioniert Chord-Knoten im Ring.
 * @author Leo Nobach
 * @version 3.0, 03.11.2008
 *
 */
public class ChordRingPositioner extends RingPositioner{
	
	private static final BigInteger MAX_KEY_SIZE;


	static {
		byte[] sha1hash_max = new byte[20];
		for (int i = 0; i < 20; i++) sha1hash_max[i] = -1;
		MAX_KEY_SIZE = new BigInteger(1, sha1hash_max);
		//Erzeugt den größten BigInteger mit 20 Byte, den es gibt.
	}


	@Override
	protected double getPositionOnRing(OverlayNode nd) {
		if (nd instanceof ChordNode) {
			
			ChordNode node;
			node = (ChordNode)nd;
			
			return node.getChordID().getValue().doubleValue() / MAX_KEY_SIZE.doubleValue();
		} else return 0;
	}
			

	
}
