package de.tud.kom.p2psim.impl.util.vis.analyzer.ol.gnutella;

import java.awt.Color;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayNodeMetric;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;

/**
 * Anzahl Documents, die der Host verwaltet
 * @author Leo Nobach
 * @version 3.0, 10.11.2008
 *
 */
public class DocCountM extends OverlayNodeMetric {

	public DocCountM() {
		this.setColor(new Color (200, 0, 255));
	}

	@Override
	public String getValue(VisOverlayNode node){
		Object attr = node.getAttribute("doc_count");
		
		if (attr != null) return attr.toString();
		else return null;
	}

	@Override
	public String getName() {
		return "Anzahl Documents";
	}

	@Override
	public String getUnit() {
		return null;
	}

	@Override
	public boolean isNumeric() {
		return true;
	}

}
