package de.tud.kom.p2psim.impl.util.vis.analyzer.positioners;

import java.util.List;

import de.tud.kom.p2psim.api.common.Host;
import de.tud.kom.p2psim.impl.util.vis.analyzer.OverlayAdapter;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.Coords;

/**
 * Ein Positioner, der sämtliche Overlay-Adapter und deren Positioner
 * zur Hilfe nimmt, um Knoten zu platzieren
 * @author 
 * @version 3.0, 20.11.2008
 *
 */
public abstract class MultiPositioner {

	List<OverlayAdapter> adapters = null;
	
	/**
	 * Setzt die verwendeten OverlayAdapter
	 * @param adapters
	 */
	public void setAdapters(List<OverlayAdapter> adapters) {
		this.adapters = adapters;
	}
	
	/**
	 * Liefert den Positioner an der XML-Config-Stelle posInCfg
	 * @param posInCfg
	 * @return
	 */
	protected OverlayAdapter getAdapterAt(int posInCfg) {
		return adapters.get(posInCfg);
	}
	
	protected List<OverlayAdapter> getAllAdapters() {
		return adapters;
	}

	/**
	 * Gibt die schematische Position für host zurück.
	 * @param host
	 * @return die schematische Position für host
	 */
	public abstract Coords getSchematicHostPosition(Host host);
	
}
