package de.tud.kom.p2psim.impl.util.vis.analyzer.positioners;

import de.tud.kom.p2psim.api.common.Host;
import de.tud.kom.p2psim.api.overlay.OverlayNode;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.Coords;

/**
 * Sucht für einen OverlayNode die passende schematische Position.
 * 
 * @author Leo Nobach
 * @version 3.0, 20.11.2008
 *
 */
public interface SchematicPositioner {

	/**
	 * Gibt die schematische Position für host, bzw node zurück.
	 * 
	 * Schematische Positionen dürfen nur zwischen 0 und 1 auf beiden
	 * Koordinatenachsen liegen, sonst kann das zu Darstellungsproblemen
	 * führen.
	 * 
	 * @param host
	 * @param node
	 * @return schematische Host-Position
	 */
	public Coords getSchematicHostPosition(Host host, OverlayNode node);
	
}
