package de.tud.kom.p2psim.impl.util.vis.analyzer.positioners.generic;

import de.tud.kom.p2psim.api.common.Host;
import de.tud.kom.p2psim.api.overlay.OverlayNode;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.Coords;

/**
 * Der Server sitzt in der Mitte, die Clients sind um ihn rum angesiedelt.
 * @author Leo Nobach
 * @version 3.0, 15.11.2008
 *
 */
public abstract class ClientServerPartitionRingPositioner extends FCFSPartitionRingPositioner{

	@Override
	public Coords getSchematicHostPosition(Host host, OverlayNode nd) {
		
		
		if (isServer(host, nd)) {
			return new Coords(RingPositioner.offset_x, RingPositioner.offset_y);
		} else {	
			return super.getSchematicHostPosition(host, nd); 
		}

	}
	
	/**
	 * Ob der angegebene Host, die angegebene OverlayNode der Server ist
	 * 
	 * @param host
	 * @param nd
	 * @return
	 */
	public abstract boolean isServer(Host host, OverlayNode nd);
	
}
