package de.tud.kom.p2psim.impl.util.vis.analyzer.positioners.generic;

import java.util.HashMap;
import java.util.Map;

import de.tud.kom.p2psim.api.overlay.OverlayNode;

/**
 * Positioniert die Knoten in einem Ring, indem der Ring in zwei Hälften geteilt wird,
 * dessen Hälften wieder in 2 Teile usw.
 * 
 * @author Leo Nobach
 * @version 3.0, 15.11.2008
 *
 */
public class FCFSPartitionRingPositioner extends RingPositioner{
	
	Map<OverlayNode, Double> positions = new HashMap<OverlayNode, Double>();
	
	int currentPartExp = 0;
	int currentPartCount = 1;
	
	@Override
	protected double getPositionOnRing(OverlayNode nd) {
		if (positions.containsKey(nd)) return positions.get(nd);
		
		double result = currentPartCount/Math.pow(2, currentPartExp);
		
		currentPartCount = currentPartCount +2;
		if (currentPartCount >= Math.pow(2, currentPartExp)) {
			currentPartExp++;
			currentPartCount = 1;
		}
		
		positions.put(nd, result);
		
		return result;
	}

}
