package de.tud.kom.p2psim.impl.util.vis.api.metrics;

/**
 * Eine gebundene Metrik ist eine Metrik, die ihren Wert ausspuckt für
 * einen Knoten/eine Kante, an die sie gebunden wurde, und damit ohne
 * eine explizite Angabe eines Knotens/einer Kante auskommt.
 * 
 * @author Leo Nobach
 *
 */
public abstract class BoundMetric extends Metric{
	
	protected Metric m;
	
	public BoundMetric(Metric m) {
		this.m = m;
	}
	
	/**
	 * Gibt den Wert der Metrik zum aktuellen Zeitpunkt zurück, abhängig 
	 * vom Objekt, an das sie gebunden wurde.
	 * @return
	 */
	public abstract String getValue();
	
	
	@Override
	public String getName() {
		return m.getName();
	}
	
	@Override
	public boolean isActivated() {
		return m.isActivated();
	}
	
	@Override
	public void setActivated(boolean activated) {
		m.setActivated(activated);
	}
	
	@Override
	public String getUnit() {
		return m.getUnit();
	}
	
	@Override
	public boolean isNumeric() {
		return m.isNumeric();
	}
	
}
