package de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.BoundMetric;
import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayEdgeMetric;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;

/**
 * Adapter/Decorator, mit dem eine Metrik an eine Kante gebunden wird.
 * Damit ist es dann nicht mehr nötig, eine Kante zu übergeben, da die Metrik
 * bereits an eine Kante gebunden ist.
 * 
 * @author Leo Nobach
 *
 */
public class BoundOverlayEdgeMetric extends BoundMetric{
	

	VisOverlayEdge e;
	OverlayEdgeMetric m;
	
	public BoundOverlayEdgeMetric(VisOverlayEdge e, OverlayEdgeMetric m) {
		super(m);
		this.m = m;
		this.e = e;
	}

	@Override
	public String getValue() {
		return m.getValue(e);
	}
	
}
