package de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.BoundMetric;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;


/**
 * Adapter/Decorator, mit dem eine Metrik an einen Knoten gebunden wird.
 * Damit ist es dann nicht mehr nötig, einen Knoten zu übergeben, da die Metrik
 * bereits an einen Knoten gebunden ist.
 * 
 * @author Leo Nobach
 *
 */
public class BoundOverlayNodeMetric extends BoundMetric{
	
	OverlayNodeMetric m;
	VisOverlayNode n;
	
	public BoundOverlayNodeMetric(VisOverlayNode n, OverlayNodeMetric m) {
		super(m);
		this.m = m;
		this.n = n;
	}

	@Override
	public String getValue() {
		return m.getValue(n);
	}
	
}
