package de.tud.kom.p2psim.impl.util.vis.api.visualization;

import java.awt.event.KeyListener;

import javax.swing.JToolBar;

import de.tud.kom.p2psim.impl.util.vis.model.MetricObject;
import de.tud.kom.p2psim.impl.util.vis.model.flashevents.FlashEvent;

/**
 * Interface einer Klasse, die für das
 * Visualisieren eines Datenmodells zuständig sein soll.
 * 
 * @author Leo Nobach
 *
 */
public interface Visualization {
	
	/**
	 * Ein individuelles Menü für die Visualisierungskomponente
	 */
	public JToolBar getVisualizationSpecificToolbar();
	
	public void addVisActionListener(VisActionListener val);
	
	public void queueFlashEvent(FlashEvent e);
	
	/**
	 * Setzt ein Hintergrundbild. Falls keins verwendet werden soll, null angeben.
	 * @param path
	 */
	public void setBackgroundImagePath(String path);
	
	/**
	 * Gibt den KeyListener zurück, der die Tastatureingaben für die 
	 * Visualisierungsoberfläche behandelt
	 * @return
	 */
	public KeyListener getVisKeyListener();
	
	/**
	 * Gibt das im Visualisierungsfenster gerade ausgewählte Objekt zurück
	 * @return
	 */
	public MetricObject getSelectedObject();
	
	public void setSimulatorStillRunning(boolean running);
	
}
