package de.tud.kom.p2psim.impl.util.vis.controller.commands;

import javax.swing.JOptionPane;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.util.Config;

/**
 * Schließt die Anwendung
 * @author Leo Nobach
 *
 */

public class CloseApplication implements Command{
	
	public static final String CONF_PATH = "UI/MainWindow/ForceClose";
	
	@Override
	public void execute() {
		
		if (! forceClose()) {
		
			if (Controller.getModel() != null && Controller.getModel().isUnsaved()) {
				switch (JOptionPane.showConfirmDialog(Controller.getUIMainWindow(), 
						"Die aktuellen Visualisierungsaufzeichnungen wurden noch nicht gespeichert. Sollen sie jetzt gespeichert werden?", 
						"Beenden", JOptionPane.YES_NO_CANCEL_OPTION)) {
				case JOptionPane.CANCEL_OPTION : return;
				case JOptionPane.NO_OPTION : break;
				case JOptionPane.YES_OPTION : new SaveToFile().execute();
				
				}
			}
			
			
			/*	//"Wirklich beenden?" ist zu blöd. Gerade wenn man öfters seine Impl. testet.
			
			if (JOptionPane.showConfirmDialog(Controller.getUIMainWindow(), 
					"Wirklich beenden?", 
					"Beenden", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) Controller.deinit();
		
			*/
			
		}
		
		Controller.deinit();
		
	}

	private boolean forceClose() {
		return Config.getValue(CONF_PATH, false);
	}
}
