package de.tud.kom.p2psim.impl.util.vis.controller.commands;

import javax.swing.JOptionPane;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.ui.common.dialogs.RecordFileChooser;

/**
 * Öffnet eine Datei
 * @author Leo Nobach
 *
 */
public class LoadFromFile implements Command{

	@Override
	public void execute() {
		
		if (Controller.getModel() != null && Controller.getModel().isUnsaved()) {
			switch (JOptionPane.showConfirmDialog(Controller.getUIMainWindow(), 
					"Die aktuellen Visualisierungsaufzeichnungen wurden noch nicht gespeichert. Sollen sie jetzt gespeichert werden?", 
					"Laden einer Aufzeichnung", JOptionPane.YES_NO_CANCEL_OPTION)) {
			case JOptionPane.CANCEL_OPTION : return;
			case JOptionPane.NO_OPTION : break;
			case JOptionPane.YES_OPTION : new SaveToFile().execute();
			
			}
		}
		
		RecordFileChooser fc = new RecordFileChooser();
		if (fc.askForOpen()) {
			
			Controller.getModel().setUnsaved(false);
		}
		
	}

	
	
}