package de.tud.kom.p2psim.impl.util.vis.controller.player;

/**
 * Reagiert auf Ereignisse des Players
 * @author Leo Nobach
 *
 */
public interface PlayerEventListener {

	/**
	 * Ausführung beim Beginn des Abspielvorgangs
	 */
	public void play();
	
	/**
	 * Ausführung bei Pause
	 */
	public void pause();
	
	/**
	 * Ausführung beim Stoppen des Abspielvorgangs
	 */
	public  void stop();
	
	/**
	 * Ausführung beim Forward
	 */
	public void forward();
	
	/**
	 * Ausführung bei Reverse
	 */
	public void reverse();

	/**
	 * Ausführung, wenn die Abspielgeschwindigkeit sich verändert
	 * @param speed
	 */
	public void speedChange(int speed);
	
	/**
	 * Ausführung, wenn die Quantisierung sich verändert
	 */
	public void quantizationChange(double quantization);
	
}
