package de.tud.kom.p2psim.impl.util.vis.gnuplot;

import java.util.Collection;
import java.util.HashMap;

/**
 * Ergebnistabelle: Beliebige Objekte als Spalten-Überschrift.
 * 
 * Zeit, Objekt1, Objekt2 ..... Objekt n t1,
 * 
 * @author Leo Nobach
 * 
 */

public class ResultTable
{

	long[] t;

	HashMap<Object, String[]> metric_values = new HashMap<Object, String[]>();

	int length;

	public ResultTable(int length, final Collection<Object> obj)
	{
		this.length = length;
		t = new long[length];
		for (Object o : obj)
		{
			metric_values.put(o, new String[length]);
		}
	}

	/**
	 * Gibt die Objekte zurück, die die Spaltenüberschrift definieren.
	 * 
	 * @return
	 */
	public Collection<Object> getObjects()
	{
		return metric_values.keySet();
	}

	public void setTimeAt(int pos, long time)
	{
		t[pos] = time;
	}

	public long getTimeAt(int pos)
	{
		return t[pos];
	}

	public void setValueForAt(Object o, int pos, String value)
	{
		if (metric_values.get(o) == null)
			throw new IllegalArgumentException(o + " ist nicht enthalten in der Tabelle");
		metric_values.get(o)[pos] = value;
	}

	public String getValueForAt(Object o, int pos)
	{
		return metric_values.get(o)[pos];
	}

}
