package de.tud.kom.p2psim.impl.util.vis.gnuplot;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * Schreibt die Resultate des Gnuplot-Exports in eine Datei, in einem
 * einfachen, tabulatorgetrennten Format.
 * @author Leo Nobach
 *
 */
public class SimpleGnuplotFileWriter implements IResultFileWriter{

	@Override
	public void writeToFile(File f, ResultTable results) throws IOException {
	    FileWriter fstream = new FileWriter(f);
	        BufferedWriter out = new BufferedWriter(fstream);
	    out.write("# Gnuplot chart generated by PeerfactSim.KOM Visualization\n");
	    out.write("# \n");
	    out.write("# Time	");
	    for (Object o : results.getObjects()) {
	    	out.write(o.toString() + "	");
	    }
	    out.write("\n");
	    
	    for (int i = 0; i < results.length; i++) {
	    	out.write(String.valueOf(results.getTimeAt(i)));
	    	out.write("	");
	    	for (Object o : results.getObjects()) {
		    	out.write(results.getValueForAt(o, i));
		    	out.write("	");
		    }
	    	out.write("\n");
	    }
	    
	    out.close();
	}

}
