package de.tud.kom.p2psim.impl.util.vis.metrics.overlay;

import java.awt.Color;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayEdgeMetric;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;

/**
 * Klassenname einer Nachricht, die durch eine Kante repräsentiert wird.
 * Ohne kompletten Paketpfad
 * @author Leo Nobach
 * @version 3.0, 20.10.2008
 *
 */
public class EdgeClassName extends OverlayEdgeMetric {
	
	public EdgeClassName() {
		this.setColor(new Color (0, 100, 60));
	}
	
	@Override
	public String getValue(VisOverlayEdge edge){
		Object attr = edge.getAttribute("msg_class");

		if (attr != null) return attr.toString();
		else return null;
	}

	@Override
	public String getName() {
		return "Klassenname der Nachricht";
	}

	@Override
	public String getUnit() {
		return "";
	}

	@Override
	public boolean isNumeric() {
		return false;
	}
	
}
