package de.tud.kom.p2psim.impl.util.vis.metrics.overlay;

import java.awt.Color;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayEdgeMetric;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;

/**
 * Name des Overlays/der Overlays, deren Semantik die Kante verdeutlicht.
 * (Benutzt Knotenattribut "overlay")
 * @author Leo Nobach
 * @version 3.0, 20.10.2008
 *
 */
public class EdgeOverlayName extends OverlayEdgeMetric {

	public EdgeOverlayName() {
		this.setColor(new Color (200, 100, 0));
	}
	
	@Override
	public String getValue(VisOverlayEdge edge){
		Object attr = edge.getAttribute("overlay");

		if (attr != null) return attr.toString();
		else return null;
	}

	@Override
	public String getName() {
		return "Overlay (Verbindung)";
	}

	@Override
	public String getUnit() {
		return "";
	}

	@Override
	public boolean isNumeric() {
		return false;
	}
	
}
