package de.tud.kom.p2psim.impl.util.vis.metrics.overlay;

import java.awt.Color;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayNodeMetric;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;


/**
 * Metrik: Die Anzahl aller Nachbarknoten eines Knotens
 * 
 * @author Leo Nobach
 *
 */
public class NodeNeighbors extends OverlayNodeMetric{

	public NodeNeighbors() {
		this.setColor(Color.BLUE);
	}
	
	@Override
	public String getValue(VisOverlayNode node) {
		//System.out.println(node.edges);
		return String.valueOf(node.edges.size());

	}

	@Override
	public String getName() {
		return "Anzahl Nachbarn";
	}

	@Override
	public String getUnit() {
		return "Knoten";
	}

	@Override
	public boolean isNumeric() {
		return true;
	}
	
}
