package de.tud.kom.p2psim.impl.util.vis.metrics.overlay;

import java.awt.Color;
import java.util.List;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayNodeMetric;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;


	/**
	 * Name des Overlays/der Overlays, die der Knoten benutzt.
	 * (Benutzt Knotenattribut "overlay")
	 * @author Leo Nobach
	 * @version 3.0, 20.10.2008
	 *
	 */
	public class NodeOverlayName extends OverlayNodeMetric{

	public NodeOverlayName() {
		this.setColor(new Color (100, 200, 0));
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public String getValue(VisOverlayNode node){
		Object attr = node.getAttribute("overlay");
		
		if (attr != null && attr instanceof List) {
			return printCommaSeparated((List<Object>) attr);
		}
		else if (attr != null) return attr.toString();
		else return null;
	}

	/**
	 * Gibt eine Liste als String aus, wobei die Elemente
	 * durch ein Komma getrennt sind. Bei Objekten wird dafür
	 * toString() verwendet.
	 * @param attr
	 * @return
	 */
	private String printCommaSeparated(List<Object> attr) {
		String result = "";
		boolean setComma = false;
		for (Object o :  attr) {
			if (setComma) result += ",";
			result += o.toString();
			setComma = true;
		}
		return result;
	}

	@Override
	public String getName() {
		return "Overlay (Knoten)";
	}

	@Override
	public String getUnit() {
		return "";
	}

	@Override
	public boolean isNumeric() {
		return false;
	}

	
}
