package de.tud.kom.p2psim.impl.util.vis.metrics.overlay;

import java.text.DecimalFormat;
import java.util.List;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayUniverseMetric;
import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.Node;

public class UniverseNeighbors extends OverlayUniverseMetric {
	
	@Override
	public String getValue() {
		
		List<Node<VisOverlayNode, VisOverlayEdge>> nodes
			= Controller.getModel().getOverlayGraph().nodes;
		
		int totalNeighbors = 0;
		
		for (Node<VisOverlayNode, VisOverlayEdge> node : nodes) {
			
			totalNeighbors += node.edges.size();
		}
		
		if (nodes.size() == 0) return null;
		
		double result = (double)totalNeighbors / (double)nodes.size();
		
		return new DecimalFormat("#.0").format(result).toString();
		
	}

	@Override
	public String getName() {
		return "Durchschnittliche Anzahl Nachbarn";
	}

	@Override
	public String getUnit() {
		return null;
	}

	@Override
	public boolean isNumeric() {
		return true;
	}

}
