package de.tud.kom.p2psim.impl.util.vis.model;

import de.tud.kom.p2psim.impl.util.vis.model.overlay.FlashOverlayEdge;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.VisRectangle;

/**
 * Lässt sich über alle Elemente des Datenmodells iterieren, 
 * erst über Knoten, dann über Kanten.
 * Kann die Iteration stoppen.
 * @author Leo
 *
 */
public interface ModelIterator {

	/**
	 * Gibt zurück, ob der Iterator bei der nächsten
	 * Gelegenheit gestoppt werden soll.
	 * @return
	 */
	public boolean shallStop();
	
	/**
	 * Soll nur über die Knoten und Kanten iteriert werden,
	 * die die höchste Priorität haben?
	 * @see VisOverlayEdge
	 * @return
	 */
	public boolean onlyHighestPrio();
	
	public void overlayEdgeVisited(VisOverlayEdge edge);
	
	public void overlayNodeVisited(VisOverlayNode node);
	
	public void rectangleVisited(VisRectangle rect);
	

	/**
	 * Aufruf bei Besuch einer FlashOverlayEdge
	 * @see FlashOverlayEdge
	 * @param e
	 */
	public void flashOverlayEdgeVisited(FlashOverlayEdge e);
	
}
