package de.tud.kom.p2psim.impl.util.vis.model;

/**
 * Wartet auf nötige Aktualisierungen der Anzeige.
 * 
 * @author Leo Nobach
 *
 */
public interface ModelRefreshListener {

	/**
	 * Wird ausgeführt, wenn das Modell einen Refresh benötigt.
	 */
	public void modelNeedsRefresh(VisDataModel model);
	
	/**
	 * Wurd ausgeführt, wenn ein neues Datenmodell geladen wurde.
	 */
	public void newModelLoaded(VisDataModel model);
	
	/**
	 * Wird ausgeführt, wenn das Datenmodell durch die fertige
	 * Simulation vollständig ist.
	 */
	public void simulationFinished(VisDataModel model);
	
}
