package de.tud.kom.p2psim.impl.util.vis.model;

import java.awt.Color;

import javax.swing.ImageIcon;

/**
 * Ein Objekt, das außer einer Klasse einen unterscheidbaren Typ hat.
 * @author Leo Nobach
 * @version 3.0, 11.12.2008
 *
 */
public interface TypeObject {

	/**
	 * Gibt eine für den Typen eindeutige ID aus
	 * @return
	 */
	public int getUniqueTypeIdentifier();
	
	/**
	 * Gibt einen Namen für diesen Typen zurück
	 * @return
	 */
	public String getTypeName();
	
	/**
	 * Gibt ein Icon für den Typ dieses Objekts zurück.
	 * @return
	 */
	public ImageIcon getRepresentingIcon();
	
	/**
	 * Gibt eine Farbe für den Typ dieses Objekts zurück.
	 * @return
	 */
	public Color getColor();
	
}
