package de.tud.kom.p2psim.impl.util.vis.model.events;

import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.controller.player.Event;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;

/**
 * Eine Verbindung tritt dem Szenario bei.
 * @author Leo Nobach
 *
 */
public class EdgeAdded extends Event implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1878312595608244036L;
	
	protected VisOverlayEdge edge;
	
	public EdgeAdded(VisOverlayEdge edge) {
		this.edge = edge;
	}
	
	
	@Override
	public void makeHappen() {
		Controller.getModel().getOverlayGraph().addEdge(edge);
	}

	@Override
	public void undoMakeHappen() {
		Controller.getModel().getOverlayGraph().removeEdge(edge);
		
	}

	public String toString() {
		return "EdgeAdded: " + edge.toString();
	}

}
