package de.tud.kom.p2psim.impl.util.vis.model.events;

import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.controller.player.Event;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.FlashOverlayEdge;

/**
 * Eine Verbindung tritt kurz auf und verschwindet dann wieder.
 * @author Leo Nobach
 * @version 3.0, 19.10.2008
 *
 */
public class EdgeFlashing extends Event implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 111039272563104948L;
	
	private FlashOverlayEdge edge;

	public EdgeFlashing(FlashOverlayEdge edge) {
		this.edge = edge;
	}
	
	@Override
	public void makeHappen() {
		Controller.getVisApi().queueFlashEvent(edge);
	}

	@Override
	public void undoMakeHappen() {
		//eventuell noch einmal:
		//Controller.getModel().getOverlayGraph().addEdge(edge);
		//ist Geschmackssache, was besser aussieht.
		//Wäre sinnvoll, wenn Rückwärtslauf implementiert wird.
	}
	
	public String toString() {
		return "EdgeFlashing: " + edge.toString();
	}

}
