package de.tud.kom.p2psim.impl.util.vis.model.events;

import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.controller.player.Event;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;

/**
 * Eine Verbindung verlässt das Szenario.
 * @author Leo Nobach
 *
 */
public class EdgeRemoved extends Event implements Serializable {
	
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -9125455535458495500L;
	
	protected VisOverlayEdge edge;
	
	public EdgeRemoved(VisOverlayEdge edge) {
		this.edge = edge;
	}
	
	
	@Override
	public void makeHappen() {
		Controller.getModel().getOverlayGraph().removeEdge(edge);
	}

	@Override
	public void undoMakeHappen() {
		Controller.getModel().getOverlayGraph().addEdge(edge);
		
	}

	public String toString() {
		return "EdgeRemoved: " + edge.toString();
	}

}
