package de.tud.kom.p2psim.impl.util.vis.model.events;

import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.controller.player.Event;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;

/**
 * Eine Message wird gesendet.
 * @author Leo Nobach
 *
 */
public class MessageSent extends Event implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4524337256193794212L;

	private VisOverlayNode from;
	
	private VisOverlayNode to;
	
	private String messageType;
	
	public MessageSent(VisOverlayNode from, VisOverlayNode to, String messageType){
		this.from = from;
		this.to = to;
		this.messageType = messageType;
	}
	
	@Override
	public void makeHappen() {
		// TODO Was passiert auf der GUI, wenn Message gesendet wird? Alles über Metriken lösen?
	}

	@Override
	public void undoMakeHappen() {
		// TODO Was passiert auf der GUI, wenn Message gesendet wird? Alles über Metriken lösen?
		
	}
	
	public VisOverlayNode getFrom(){
		return from;
	}
	
	public VisOverlayNode getTo(){
		return to;
	}
	
	public String getMessageType(){
		return messageType;
	}
	
	public String toString() {
		return "Message sent: " + getMessageType();
	}

}
