package de.tud.kom.p2psim.impl.util.vis.model.events;

import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.controller.player.Event;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;

/**
 * Ein Peer tritt dem Szenario bei.
 * 
 * @author Leo Nobach
 *
 */
public class NodeAdded extends Event implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 4152348938063598815L;
	
	protected VisOverlayNode node;
	
	public NodeAdded(VisOverlayNode node) {
		this.node = node;
	}
	
	
	@Override
	public void makeHappen() {
		Controller.getModel().getOverlayGraph().addNode(node);
	}

	@Override
	public void undoMakeHappen() {
		Controller.getModel().getOverlayGraph().removeNode(node);
		
	}
	
	public String toString() {
		return "NodeAdded: " + node.toString();
	}

}
