package de.tud.kom.p2psim.impl.util.vis.model.events;

import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.controller.player.Event;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;

/**
 * Ein Peer verlässt das Szenario.
 * @author Leo Nobach
 *
 */
public class NodeRemoved extends Event implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 4888277508741351362L;
	
	protected VisOverlayNode node;
	
	public NodeRemoved(VisOverlayNode node) {
		this.node = node;
	}
	
	
	@Override
	public void makeHappen() {
		Controller.getModel().getOverlayGraph().removeNode(node);
	}

	@Override
	public void undoMakeHappen() {
		Controller.getModel().getOverlayGraph().addNode(node);
		
	}

	public String toString() {
		return "NodeRemoved: " + node.toString();
	}
	
}
