package de.tud.kom.p2psim.impl.util.vis.model.events;

import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.controller.player.Event;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.VisRectangle;

public class RectangleRemoved extends Event implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -5220499892746989291L;
	
	protected VisRectangle rect;
	
	public RectangleRemoved(VisRectangle rect){
		this.rect = rect;
	}
	
	@Override
	public void makeHappen() {
		Controller.getModel().getOverlayGraph().removeRectangle(rect);
	}

	@Override
	public void undoMakeHappen() {
		Controller.getModel().getOverlayGraph().addRectangle(rect);
	}

}
