package de.tud.kom.p2psim.impl.util.vis.model.flashevents;

import de.tud.kom.p2psim.impl.util.vis.model.ModelIterator;
import de.tud.kom.p2psim.impl.util.vis.model.TypeObject;

/**
 * Ereignis, das keine Dauer hat und daher unendlich kurz ist. Es wird
 * von der Visualisierung speziell gezeichnet. Beispiele:
 * Message-Versendungen ohne festgelegte Zeit.
 * 
 * @author Leo Nobach
 * @version 3.0, 21.10.2008
 *
 */
public interface FlashEvent extends TypeObject {
	
	/**
	 * Iterator-Aufruf. Ruft die zum Objekt passende Visitorfunktion auf.
	 * @param it
	 */
	public void iterate(ModelIterator it);
	
	/**
	 * Ist von besonderer Bedeutung bei FlashEvents. Es werden nie zwei Events
	 * in einem Frame gezeichnet, die sich ähneln, damit das Bild nicht "zugemüllt"
	 * wird von vielen FlashEvents.
	 * @param e
	 * @return ob GLeichheit herrscht
	 */
	public boolean equals(Object o);
	
	/**
	 * konsistent zu equals(Object).
	 * Siehe http://www.geocities.com/technofundo/tech/java/equalhash.html
	 * @return
	 */
	public int hashCode();
}
