package de.tud.kom.p2psim.impl.util.vis.model.overlay;

import java.io.Serializable;
import java.util.Map;

/**
 * Ein Objekt mit Attributen, d.h. einer Map<String, Serializable>
 * zur Aufzeichnung.
 * @author Leo Nobach
 * @version 3.0, 27.10.2008
 *
 */
public interface AttributeObject extends Serializable{

	/**
	 * Gibt eine Map aller Attribute zurück.
	 * @return
	 */
	public Map<String, Serializable> getAttributes();
	
	/**
	 * F�gt ein Attribut ein.
	 * <b> Achtung! Alle Attribute m�ssen serializable sein! </b>
	 * @param name
	 * @param value
	 */
	public void insertAttribute(String name, Serializable value);
	
	/**
	 * Gibt das Attribut mit dem Key name zurück.
	 * @param name
	 * @return
	 */
	public Object getAttribute(String name);
	
}
