package de.tud.kom.p2psim.impl.util.vis.model.overlay;

import java.util.Vector;

import javax.swing.ImageIcon;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.BoundMetric;
import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayUniverseMetric;
import de.tud.kom.p2psim.impl.util.vis.metrics.MetricsBase;
import de.tud.kom.p2psim.impl.util.vis.model.MetricObject;
import de.tud.kom.p2psim.impl.util.vis.model.ModelIterator;


/**
 * Graph des Overlay-Netzwerks.
 * @author Leo Nobach
 *
 */
public class VisOverlayGraph extends de.tud.kom.p2psim.impl.util.vis.util.visualgraph.VisualGraph<VisOverlayNode, VisOverlayEdge> implements MetricObject{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1041089548085360017L;

	protected static final ImageIcon REPR_ICON = new ImageIcon("images/icons/model/OverlayUniverse16_16.png");
	
	/**
	 * Nicht darstellungsspezifischer Graph des Overlays.
	 * @param a
	 * @param b
	 */
	
	public VisOverlayGraph() {
		super();
	}

	@Override
	public Vector<BoundMetric> getBoundMetrics() {
		Vector<BoundMetric> res = new Vector<BoundMetric>();
		for (OverlayUniverseMetric m : MetricsBase.forOverlayUniverse().getListOfAllMetrics()) {
			res.add(m.getBoundTo());
		}
		return res;
	}
	
	@Override
	public String toString() {
		return "Szenario";
	}
	
	@Override
	public ImageIcon getRepresentingIcon() {
		return REPR_ICON;
	}

	@Override
	public void iterate(ModelIterator it) {
		//Nothing to do, the graph is invisible and unclickable yet
	}
}
