package de.tud.kom.p2psim.impl.util.vis.ui.common.DetailsPane.EdgeFilter;

import java.awt.Color;

import javax.swing.ImageIcon;
import javax.swing.table.AbstractTableModel;

import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.model.ModelFilter;
import de.tud.kom.p2psim.impl.util.vis.model.VisDataModel;

public class EdgeFilterModel extends AbstractTableModel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -7493119663427021910L;
	
	public static final ModelFilter NULL_FILTER = new ModelFilter();	

	@Override
	public int getColumnCount() {
		return 4;
	}

	@Override
	public int getRowCount() {
		return getFilter().getAllTypes().size();
	}

	@Override
	public Object getValueAt(int row, int col) {
		if (col == 0) {
			return getFilter().getAllTypes().get(row).typeIcon;
		} else if (col == 1) {
			return getFilter().getAllTypes().get(row).typeColor;
		} else if (col == 2) {
			return getFilter().getAllTypes().get(row).typeName;
		} else {
			return getFilter().getAllTypes().get(row).isTypeActivated();
		}
	}
	
	@Override
	public String getColumnName(int col) {
		if (col == 0) 
			return "";
		else if (col == 1) 
			return "";
		else if (col == 2)
			return "Name";
		else 
			return "Zeigen";
	}
	
	@Override
	public boolean isCellEditable(int row, int col)
    { return col == 3; }
	
	@Override
	public void setValueAt(Object value, int row, int col) {
        if (col == 3) {
        	getFilter().getAllTypes().get(row).setTypeActivated((Boolean) value);
        	VisDataModel.needsRefresh();
        }
        
    }
	
	@Override
	public Class<?> getColumnClass(int c) {
		if (c == 0) return ImageIcon.class;
		else if (c == 1) return Color.class;
		else if (c == 2) return String.class;
		else return Boolean.class;
    }
	
	public ModelFilter getFilter() {
		VisDataModel model = Controller.getModel();
		if (model != null) return model.getFilter();
		else return NULL_FILTER;
	}

}
