package de.tud.kom.p2psim.impl.util.vis.ui.common.DetailsPane;

import javax.swing.JTable;

import de.tud.kom.p2psim.impl.util.vis.model.ModelRefreshListener;
import de.tud.kom.p2psim.impl.util.vis.model.VisDataModel;


/**
 * SWING-Tabelle, die alle Metriken eines Objekts mit ihren Werten zeigt.
 * @author Leo Nobach
 *
 */
public class MetricsTable extends JTable implements ModelRefreshListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1071754568206817344L;

	public MetricsTable() {
		this.setModel(new MetricsTableModel());
		this.arrangeColumns();
		VisDataModel.addRefreshListener(this);
		this.getColumnModel().getColumn(1).setCellRenderer(new ColorTableCellRenderer());
	}
	
	private void arrangeColumns() {
		this.getColumnModel().getColumn(0).setPreferredWidth(25);
		this.getColumnModel().getColumn(0).setMaxWidth(35);
		this.getColumnModel().getColumn(1).setPreferredWidth(25);
		this.getColumnModel().getColumn(1).setMaxWidth(35);
		this.getColumnModel().getColumn(3).setPreferredWidth(15);
	}

	@Override
	public void modelNeedsRefresh(VisDataModel model) {
		this.repaint();
	}

	@Override
	public void newModelLoaded(VisDataModel model) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void simulationFinished(VisDataModel model) {
		// TODO Auto-generated method stub
		
	}
}
