package de.tud.kom.p2psim.impl.util.vis.ui.common.DetailsPane;

import java.util.Vector;

import javax.swing.JTable;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.BoundMetric;
import de.tud.kom.p2psim.impl.util.vis.model.ModelRefreshListener;
import de.tud.kom.p2psim.impl.util.vis.model.VisDataModel;


/**
 * SWING-Tabelle, die alle übergebenen Metriken mit ihren Werten zeigt.
 * @author Leo Nobach
 *
 */
public class ObjectMetricsTable extends JTable implements ModelRefreshListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1071754568206817344L;

	public ObjectMetricsTable() {
		VisDataModel.addRefreshListener(this);
	}
	
	private void arrangeColumns() {
		this.getColumnModel().getColumn(1).setPreferredWidth(10);
	}


	/**
	 * Übergibt der Metriktabelle einen neuen Satz von gebundenen
	 * Metriken, die dann angezeigt werden.
	 * @param boundMetrics
	 */
	public void setMetrics(Vector<BoundMetric> boundMetrics) {
		this.setModel(new ObjectMetricsTableModel(boundMetrics));
		this.arrangeColumns();
	}

	@Override
	public void modelNeedsRefresh(VisDataModel model) {
		this.repaint();
	}

	@Override
	public void newModelLoaded(VisDataModel model) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void simulationFinished(VisDataModel model) {
		// TODO Auto-generated method stub
		
	}
}
