package de.tud.kom.p2psim.impl.util.vis.ui.common.DetailsPane;

import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.BoundMetric;

/**
 * Modell der ObjectMetricsTable.
 * 
 * @author Leo Nobach
 *
 */
public class ObjectMetricsTableModel extends AbstractTableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 8805264033914855097L;

	Vector<BoundMetric> metrics;
	
	public ObjectMetricsTableModel(Vector<BoundMetric> metrics) {
		this.metrics = metrics;
	}
	
	@Override
	public int getColumnCount() {
		return 2;
	}

	@Override
	public int getRowCount() {
		return metrics.size();
	}

	@Override
	public String getColumnName(int col) {
		if (col == 0) 
			return "Name";
		else 
			return "Wert";
	}
	
	@Override
	public Object getValueAt(int row, int col) {
		
		if (col == 0) 
			return metrics.elementAt(row).getName();
		else {
			String mValue = metrics.elementAt(row).getValue();
			if (mValue == null) return getNullView();
			return mValue;
		}
	}

	/**
	 * Wird an die Zelle zum Anzeigen zurückgegeben,
	 * falls die Metrik keinen Wert hat.
	 * @return
	 */
	private Object getNullView() {
		return "<html><b>---null---</b></html>";
	}

	@SuppressWarnings("unchecked")
	@Override
	public Class getColumnClass(int c) {
		return String.class;
    }

	@Override
	public void setValueAt(Object value, int row, int col) {
                
    }
	
	@Override
	public boolean isCellEditable(int row, int col)
    { return false; }
	
}
