package de.tud.kom.p2psim.impl.util.vis.ui.common.DetailsPane;

import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;


/**
 * Zeigt die Beschreibung eines Knotens (ohne mit ihm verbundene Metriken) an.
 * 
 * @author Leo Nobach
 *
 */
public class OverlayEdgeDescriptionPane extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4703682668232902573L;
	
	private static ImageIcon EDGE_THUMB = new ImageIcon("images/icons/model/OverlayEdge32_32.png");
	
	VisOverlayEdge edge;
	
	public OverlayEdgeDescriptionPane(VisOverlayEdge edge) {
		this.edge = edge;
		this.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		
		c.gridx = 0;
		c.gridy = 0;
		c.gridheight = 2;
		
		this.add(new JLabel(EDGE_THUMB));
		
		c.gridx = 1;
		c.gridy = 0;
		c.gridheight = 1;
		
		this.add(new JLabel("Verbindung"));
		
		c.gridx = 1;
		c.gridy = 1;
		
		JLabel namelabel = new JLabel(edge.toString());
		namelabel.setFont(namelabel.getFont().deriveFont(Font.BOLD));
		this.add(namelabel, c);
		
	}

}
