package de.tud.kom.p2psim.impl.util.vis.ui.common.DetailsPane;

import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayGraph;

/**
 * Zeigt Details für das gesamte Overlay-Szenario an.
 * @author Leo Nobach
 *
 */
public class OverlayGraphDescriptionPane extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4703682668232902573L;
	
	private static ImageIcon NODE_THUMB = new ImageIcon("images/icons/model/OverlayUniverse32_32.png");
	
	VisOverlayGraph graph;
	
	JLabel nodetitle = new JLabel();
	
	public OverlayGraphDescriptionPane(VisOverlayGraph graph) {
		this.graph = graph;
		this.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		
		c.gridx = 0;
		c.gridy = 0;
		c.gridheight = 2;
		
		this.add(new JLabel(NODE_THUMB));
		
		c.gridx = 1;
		c.gridy = 0;
		c.gridheight = 1;
		
		this.nodetitle.setText(graph.toString());
		this.nodetitle.setFont(this.nodetitle.getFont().deriveFont(Font.BOLD));
		this.add(nodetitle, c);
		
		c.gridx = 1;
		c.gridy = 1;
		
		this.add(new JLabel("Gesamtes Szenario"), c);
		
	}

}
