package de.tud.kom.p2psim.impl.util.vis.ui.common.config.general;

import java.awt.Component;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.UIManager;

import de.tud.kom.p2psim.impl.util.vis.util.Config;
import de.tud.kom.p2psim.impl.util.vis.util.gui.LookAndFeel;

/**
 * ComboBox zur Auswahl eines LookAndFeels.
 * 
 * @author Leo Nobach
 *
 */
public class LaFComboBox extends JComboBox {



	/**
	 * 
	 */
	private static final long serialVersionUID = -8908823686650489258L;
	
	public LaFComboBox(List<UIManager.LookAndFeelInfo> list) {
		for (Object o : list) this.addItem(o);
		
		setStartSelection(list);
		this.setRenderer(new LaFComboBox.LaFRenderer());
	}

	private void setStartSelection(List<UIManager.LookAndFeelInfo> list) {
		for (UIManager.LookAndFeelInfo laf : list) {
			if (laf.getClassName() == LookAndFeel.getActivatedLookAndFeel()) {
				this.setSelectedItem(laf);
			}
		}
	}

	/**
	 * Schreibt die Änderungen fest
	 */
	public void commit() {
		String selectedClassName
			= ((UIManager.LookAndFeelInfo)getSelectedItem()).getClassName();
		
		Config.setValue("UI/LookAndFeel", selectedClassName);
		LookAndFeel.setLookAndFeel(selectedClassName);
	}
	
	public class LaFRenderer implements ListCellRenderer {

		@Override
		public Component getListCellRendererComponent(JList arg0, Object arg1,
				int arg2, boolean arg3, boolean arg4) {
			return new JLabel(((UIManager.LookAndFeelInfo)arg1).getName());
		}

	}
	
}
