package de.tud.kom.p2psim.impl.util.vis.ui.common.gnuplot;

import java.awt.Component;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import de.tud.kom.p2psim.impl.util.vis.util.Config;

/**
 * Für das Auswählen der betroffenen Dat-Datei.
 * @author leo
 *
 */
public class GnuplotFileChooser extends JFileChooser{

	static final String CFG_LAST_PATH = "UI/Gnuplot/lastPath";

	static final String FILE_EXTENSION = "dat";
	
	Component parent;
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -7876626268968056079L;
	
	public GnuplotFileChooser(Component parent) {
		this.parent = parent;
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Gnuplot-Tabellen", FILE_EXTENSION);
		 this.setFileFilter(filter);
		 
		 this.setCurrentDirectory(new File (Config.getValue(CFG_LAST_PATH, "")));
	}
	
	public File askWhereToSave() {
		if (this.showSaveDialog(null) == JFileChooser.APPROVE_OPTION) {
			Config.setValue(CFG_LAST_PATH, this.getSelectedFile().getAbsolutePath());
			return this.validateFileName(this.getSelectedFile());
		} else {
			return null;
		}
	}
	
	private File validateFileName(final File file) {
		
		FileFilter filter = this.getFileFilter();
		
	    if (filter.accept(file)) {
	        return file;
	    }
	    String fileName = file.getName();
	    final int index = fileName.lastIndexOf(".");
	    if (index > 0) {
	        fileName = fileName.substring(0, index);
	    }
	 
	    final String newFileName = fileName + "." + FILE_EXTENSION;
	 
	    return new File(file.getParent(), newFileName);
	} 
	
}
