package de.tud.kom.p2psim.impl.util.vis.ui.common.gnuplot;

import java.awt.BorderLayout;
import java.util.List;
import java.util.Vector;

import javax.swing.JTextArea;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.overlay.OverlayEdgeMetric;
import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.gnuplot.GnuplotExporter;
import de.tud.kom.p2psim.impl.util.vis.gnuplot.ResultTable;
import de.tud.kom.p2psim.impl.util.vis.metrics.MetricsBase;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayEdge;
import de.tud.kom.p2psim.impl.util.vis.model.overlay.VisOverlayNode;
import de.tud.kom.p2psim.impl.util.vis.util.visualgraph.Edge;

public class MetricConnectionVsTimeDialog extends MetricObjectVsTimeDialog<OverlayEdgeMetric, VisOverlayEdge>{

	/**
	 * 
	 */
	private static final long serialVersionUID = 6230110489407073653L;

	private static final String MANUAL_TXT = "Stellt ausgewählte Verbindungen bezüglich einer Metrik in einem Graph gegenüber. " +
											 "Wählen Sie die zu plottenden Verbindungen und die gewünschte Metrik, Start- und " +
											 "Endzeitpunkt, und den Intervall, in dem die Metrik abgetastet werden soll.";
	
	public MetricConnectionVsTimeDialog() {
		JTextArea manual = new JTextArea(MANUAL_TXT);
		manual.setLineWrap(true);
		manual.setWrapStyleWord(true);
		manual.setOpaque(false);
		this.add(manual, BorderLayout.NORTH);
	}
	
	@Override
	public List<OverlayEdgeMetric> getMetrics() {
		Vector<OverlayEdgeMetric> result = new Vector<OverlayEdgeMetric>();
		for (OverlayEdgeMetric m : MetricsBase.forOverlayEdges().getListOfAllMetrics()) {
			if (m.isNumeric()) result.add(m);		//Nur Metriken, die numerisch sind, werden verwendet.
		}
		
		return result;
	}

	@Override
	protected ResultTable createTable(long[] values) {
		System.out.println("Metrik ausgewählt: " + this.getSelectedMetric()); 
		return new GnuplotExporter().generateOneMetricConnVsTime(this.getListOfSelectedObjects(), this.getSelectedMetric(), values[0], values[1], values[2]);
	}

	@Override
	public List<VisOverlayEdge> getObjects() {
			List<VisOverlayEdge> res = new Vector<VisOverlayEdge>();
			for (Edge<VisOverlayNode, VisOverlayEdge> e : Controller.getModel().getOverlayGraph().edges) {
				res.add((VisOverlayEdge) e);
			}
			return res;
	}

}
