package de.tud.kom.p2psim.impl.util.vis.ui.common.gnuplot;

import java.util.List;

import javax.swing.ImageIcon;
import javax.swing.table.AbstractTableModel;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.Metric;

public class MetricTableModel<TMetric extends Metric> extends AbstractTableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7789895021882856840L;

	protected static final ImageIcon metric_icon = new ImageIcon("images/icons/misc/Metric16_16.png");
	
	List<TMetric> metrics;
	
	public MetricTableModel(List<TMetric> metrics) {
		this.metrics = metrics;
	}
	
	@Override
	public String getColumnName(int col) {
		if (col == 0) 
			return "";
		else 
			return "Metrik";
	}
	
	@Override
	public int getColumnCount() {
		return 2;
	}

	@Override
	public int getRowCount() {
		return metrics.size();
	}

	@Override
	public Object getValueAt(int row, int col) {
		if (col == 0) return metric_icon;
		else return metrics.get(row).getName();
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public Class getColumnClass(int c) {
		if (c == 0) return ImageIcon.class;
		else return String.class;
    }

}
