package de.tud.kom.p2psim.impl.util.vis.ui.common.gnuplot;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import de.tud.kom.p2psim.impl.util.vis.api.metrics.BoundMetric;
import de.tud.kom.p2psim.impl.util.vis.controller.Controller;
import de.tud.kom.p2psim.impl.util.vis.gnuplot.GnuplotExporter;
import de.tud.kom.p2psim.impl.util.vis.gnuplot.ResultTable;

public class MetricsVsTimeDialog extends MetricVsTimeBasisPanel
{

	private static final long serialVersionUID = 8884409185702564261L;

	//private JPanel checkBoxPanel;

	private Collection<BoundMetric> m = new Vector<BoundMetric>();

	private ArrayList<JCheckBox> ListOfCheckBox;

	private static final String MANUAL_TXT = "Stellt ausgewählte Metriken für das gerade ausgewählte Objekt in einem Graphen dar." +
							 "Wählen Sie die gewünschten Metriken, Start- und " +
							 "Endzeitpunkt, und den Intervall, in dem die Metrik abgetastet werden soll.";

	public MetricsVsTimeDialog()
	{
		for (BoundMetric metr : Controller.getVisApi().getSelectedObject().getBoundMetrics()) {
			if (metr.isNumeric()) m.add(metr);
		}
		createContentPanel();
		
		JTextArea manual = new JTextArea(MANUAL_TXT);
		manual.setLineWrap(true);
		manual.setWrapStyleWord(true);
		manual.setOpaque(false);
		this.add(manual, BorderLayout.NORTH);
	}

	public void createContentPanel()
	{
		createCheckBox();
	}

	private void createCheckBox()
	{
		/*
		checkBoxPanel = new JPanel();
		checkBoxPanel.setLayout(null);
		checkBoxPanel.setBounds(55, 20, 200, 200);
		 */
		
		ListOfCheckBox = new ArrayList<JCheckBox>();

		JPanel checkBox = new JPanel();
		//checkBox.setBorder(BorderFactory.createLoweredBevelBorder());
		checkBox.setBackground(Color.WHITE);
		checkBox.setPreferredSize(new Dimension(150, 150));
		checkBox.setBounds(50, 50, 200, 200);
		checkBox.setLayout(new BoxLayout(checkBox, BoxLayout.PAGE_AXIS));

		for (BoundMetric boundMetric : m)
		{
			JCheckBox box = new JCheckBox(boundMetric.getName());
			ListOfCheckBox.add(box);
			checkBox.add(box);
		}

		this.add(new JScrollPane(checkBox), BorderLayout.CENTER);
	}

	protected ResultTable createTable(long[] values) {
		// << das sind die in der CheckBox ausgewählten.
		Collection<BoundMetric> selectedMetrics = new Vector<BoundMetric>();
		for (JCheckBox checbox : ListOfCheckBox)
			if (checbox.isSelected())
			{
				String metric = checbox.getText();
				for (BoundMetric boundMetric : m)
					if (boundMetric.getName().equals(metric))
					{
						selectedMetrics.add(boundMetric);
						break;
					}
			}
		return new GnuplotExporter().generateResultTable(selectedMetrics, values[0], values[1], values[2]);
	}
	
}
