package de.tud.kom.p2psim.impl.util.vis.ui.common.toolbar.elements;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.ImageIcon;

import de.tud.kom.p2psim.impl.util.vis.controller.commands.Command;

/**
 * Diese Klasse stellt einen Knopf dar, den man drücken kann, damit er
 * ein oder mehrere Kommandos, implementiert nach dem Interface
 * controller.commands.Command, ausführt.
 * Einfach das Kommando mittels addCommand(Command c) anhängen, und
 * es wird ausgeführt, sobald man auf den Knopf drückt.
 * @author Leo
 *
 */
public class SimpleToolbarButton extends JButton{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -7278102175284474958L;
	
	public SimpleToolbarButton() { 
		super();
	}
	
	public SimpleToolbarButton(ImageIcon icon) { 
		super(icon);
	}
	
	public void addCommand (Command c) {
		this.addActionListener(new CommandAdapter(c));
	}
	
	public class CommandAdapter implements ActionListener{
		
		Command adaptedCommand;
		
		public CommandAdapter(Command c) {
			this.adaptedCommand = c;
		}
		
		@Override
		public void actionPerformed(ActionEvent e) {			
			this.adaptedCommand.execute();
		}
		
	}
	
}
