package de.tud.kom.p2psim.impl.util.vis.util.gui;

import javax.swing.JCheckBox;

import de.tud.kom.p2psim.impl.util.vis.util.Config;

/**
 * Wie JCheckBox, nur dass der Wert dieser CheckBox in der XML-Config gespeichert wird,
 * unter configPath
 * @author Leo Nobach
 *
 */
public class JConfigCheckBox extends JCheckBox{

	/**
	 * 
	 */
	private static final long serialVersionUID = 4395710891110224842L;
	
	public String configPath;
	
	public JConfigCheckBox(String caption, String configPath) {
		super(caption);
		create(configPath);
	}
	
	public JConfigCheckBox(String configPath) {
		create(configPath);
	}
	
	/**
	 * Pseudokonstruktor
	 * @param Pfad zur Config
	 */
	public void create(String configPath) {
		this.configPath=configPath;
		if (Config.getValue(configPath, 0) == 1) {
			this.setSelected(true);
		}
	}

	public void saveSettings() {
		int value = 0;
		if (this.isSelected()) value = 1;
		
		Config.setValue(configPath, value);
	}
}
