package de.tud.kom.p2psim.impl.util.vis.util.gui;

import java.util.Arrays;
import java.util.Vector;

import javax.swing.UIManager;

import de.tud.kom.p2psim.impl.util.vis.util.Config;

public class LookAndFeel {
	
	
	public static Vector<UIManager.LookAndFeelInfo> getAllLookAndFeels() {
		Vector<UIManager.LookAndFeelInfo> v = new Vector<UIManager.LookAndFeelInfo>();
		v.addAll(Arrays.asList(UIManager.getInstalledLookAndFeels()));
		return v;
	}
	
	public static void  setLookAndFeel(){
		setLookAndFeel(Config.getValue("UI/LookAndFeel", getDefaultLaF()));
	}
	
	private static String getDefaultLaF() {
		return UIManager.getSystemLookAndFeelClassName();
	}
	
	public static String getActivatedLookAndFeel() {
		return UIManager.getLookAndFeel().getClass().getName();
	}

	/**
	 * Ändert das LookAndFeel entsprechend der Einstellungen.
	 *
	 */
	public static void  setLookAndFeel(String laf) {
		
		try {
			UIManager.setLookAndFeel(laf);
		} catch (Exception e) {
			System.out.println("Konnte Look-and-Feel " + laf + " nicht laden. " +
					"Wahrscheinlich ist dies nicht installiert.");
		}
	}

	/*
	private static boolean setWindowsLookAndFeel() {
		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			return true;
		} catch (Exception e) { 
			System.out.println("Konnte Windows LaF nicht laden, versuche es mit GTK");
			return false;
		}
	}
	
	private static boolean setGTKLookAndFeel() {
		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
			return true;
		} catch (Exception e) { 
			System.out.println("Konnte GTK LaF nicht laden, versuche es mit Default");
			return false;
		}
	}
	*/
}
