package de.tud.kom.p2psim.impl.util.vis.util.visualgraph;

import java.io.Serializable;

/**
 * Positionsinfos, die für Objekte in der Visualisierung von Bedeutung sind.
 * @author Leo Nobach
 * @version 3.0, 03.11.2008
 *
 */
public class PositionInfo implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 3828228790124277563L;
	
	Coords topo_coords;
	Coords schem_coords;
	
	
	/**
	 * Konstruktor ohne schematische Koordinaten
	 * @param topo_coords
	 */
	public PositionInfo(Coords topo_coords) {
		this.topo_coords = topo_coords;
		this.schem_coords = null;
	}
	
	/**
	 * Standard-Konstruktor.
	 * @param topo_coords
	 * @param schem_coords
	 */
	public PositionInfo(Coords topo_coords, Coords schem_coords) {
		this.topo_coords = topo_coords;
		this.schem_coords = schem_coords;
	}

	/**
	 * Gibt die topologischen Koordinaten zurück
	 * @return
	 */
	public Coords getTopoCoords() {
		return topo_coords;
	}

	/**
	 * Setzt die topologischen Koordinaten
	 * @param topo_coords
	 */
	public void setTopoCoords(Coords topo_coords) {
		this.topo_coords = topo_coords;
	}

	/**
	 * Gibt die schematischen Koordinaten eines Knoten zurück.
	 * Wenn nicht existent, die topologischen Koordinaten.
	 * @return
	 */
	public Coords getSchemCoords() {
		if (schem_coords == null) return topo_coords;
		return schem_coords;
	}

	/**
	 * Setzt die schematischen Koordinaten
	 * @param schem_coords
	 */
	public void setSchemCoords(Coords schem_coords) {
		this.schem_coords = schem_coords;
	}

}
