package de.tud.kom.p2psim.impl.util.vis.util.visualgraph;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import java.io.Serializable;

import de.tud.kom.p2psim.impl.util.vis.model.ModelIterator;

public class VisRectangle implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2376709419959105951L;

	Color color;
	
	Point point1;
	
	Point point2;

	public VisRectangle(Point point1, Point point2, Color color){
		this.point1 = point1;
		this.point2 = point2;
		this.color = color;
	}
	
	public Point getPoint1(){
		return point1;
	}
	
	/**
	 * @return the point2
	 */
	public Point getPoint2() {
		return point2;
	}
	
	public Dimension getDimension(){
		return new Dimension(point2.x - point1.x, 
							 point2.y - point1.y);
	}
	
	public Color getColor(){
		return color;
	}
	
	public void iterate(ModelIterator it) {
		it.rectangleVisited(this);
	}
	

}
