package de.tud.kom.p2psim.impl.util.vis.visualization2d.toolbar;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;

import de.tud.kom.p2psim.impl.util.vis.model.VisDataModel;
import de.tud.kom.p2psim.impl.util.vis.util.Config;

public class FontSizeBox extends JPanel implements ActionListener{

	public static final String CONF_PATH = "Visualization/FontSize";
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2981360948327157441L;
	
	private static final String TOOL_TIP = "Schriftgröße";

	protected JComboBox box;
	
	public FontSizeBox() {
		box = new JComboBox(new Integer[] { 8, 10, 12, 15, 18, 20 });
		box.setEditable(true);
		box.addActionListener(this);
		box.setSelectedItem(Config.getValue(CONF_PATH, "10"));
		
		this.setLayout(new BorderLayout());

		this.add(box, BorderLayout.CENTER);
		this.add(new JLabel(new ImageIcon("images/icons/misc/font_size16_16.png")), BorderLayout.WEST);

		this.setToolTipText(TOOL_TIP);
		box.setToolTipText(TOOL_TIP);	
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		try {
			Integer.valueOf(box.getSelectedItem().toString());
			Config.setValue(CONF_PATH, box.getSelectedItem().toString());
			VisDataModel.needsRefresh();
		} catch (NumberFormatException ex) {
			System.out.println("Schriftgröße keine Zahl");
			box.setSelectedItem(Config.getValue(CONF_PATH, "10"));
		}
	}
	
}
