package de.tud.kom.p2psim.impl.util.vis.visualization2d.toolbar;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JToggleButton;

import de.tud.kom.p2psim.impl.util.vis.util.Config;
import de.tud.kom.p2psim.impl.util.vis.visualization2d.Simple2DVisualization;

public class SchematicViewButton extends JToggleButton implements ActionListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 5186748047384510370L;
	
	static final ImageIcon icon = new ImageIcon("images/icons/schematicView.png");
	static final String tooltip = "Schematische Ansicht";
	static final String CONF_PATH = "Visualization/SchematicView";

	private Simple2DVisualization vis;
	
	public SchematicViewButton(Simple2DVisualization vis) {
		super();
		this.setIcon(icon);
		this.setToolTipText(tooltip);
		this.addActionListener(this);
		this.vis = vis;
		
		this.getModel().setSelected((Config.getValue(CONF_PATH, 0)) != 0);
		
		vis.setSchematic(this.getModel().isSelected());
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		
		vis.setSchematic(this.getModel().isSelected());
		
		if (this.getModel().isSelected()) Config.setValue(CONF_PATH, 1);
			else Config.setValue(CONF_PATH, 0);
	}

}
