package de.tud.kom.p2psim.impl.util.vis.visualization2d.toolbar;

import javax.swing.ImageIcon;

import de.tud.kom.p2psim.impl.util.vis.controller.commands.Zoom;
import de.tud.kom.p2psim.impl.util.vis.ui.common.toolbar.elements.SimpleToolbarButton;
import de.tud.kom.p2psim.impl.util.vis.visualization2d.Simple2DVisualization;

/**
 * Button zum Hineinzoomen
 * 
 * @author Leo Nobach
 * @version 3.0, 06.11.2008
 *
 */
public class ZoomButton extends SimpleToolbarButton {

	/**
	 * 
	 */
	private static final long serialVersionUID = -8883086992639815840L;
	
	
	static final ImageIcon iconIn = new ImageIcon("images/icons/zoomIn.png");
	static final ImageIcon iconOut = new ImageIcon("images/icons/zoomOut.png");
	static final String tooltipIn = "Hereinzoomen";
	static final String tooltipOut = "Herauszoomen";
	
	/**
	 * Standard-Konstruktor
	 * @param zoomOut 
	 * @param vis 
	 */
	public ZoomButton(boolean zoomOut, Simple2DVisualization vis) {
		super();
		this.setIcon(zoomOut?iconOut:iconIn);
		this.setToolTipText(zoomOut?tooltipOut:tooltipIn);
		this.addCommand(new Zoom(zoomOut, vis));
	}
	
}