package de.tud.kom.p2psim.impl.network.gnp;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import de.tud.kom.p2psim.impl.network.gnp.geoip.IspLookupService;

public class IspLookupTest {

	IspLookupService ls;

	@Before
	public void setUp() {
		ls = new IspLookupService("data/GeoIP/GeoIPISP.csv");
	}

	@Test
	public void testLookup() {
		String result;

		// 33996344,33996351,"BT North Block Cambridge"
		result = ls.getISP(33996344);
		assertEquals(result, "BT North Block Cambridge");
		result = ls.getISP(33996351);
		assertEquals(result, "BT North Block Cambridge");

		// 67108864,83886079,"Level 3 Communications"
		result = ls.getISP(83886060);
		assertEquals(result, "Level 3 Communications");

		// 1503657984,1503690751,"Skycom Nordic AB"
		result = ls.getISP(1503690743);
		assertEquals(result, "Skycom Nordic AB");

	}

	@After
	public void tearDown() {

	}

}
