package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.routingtable;

import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.components.routingtable.RoutingTableEntry;
import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.types.KademliaOverlayID;
import junitx.util.PrivateAccessor;

/**
 * Helper methods for routing table tests.
 * 
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 */
public class RoutingTableTestHelper {
    
    /**
     * Returns the stale counter of RoutingTableEntry <code>e</code>.
     * 
     * @param e
     *                the RoutingTableEntry whose stale counter is of
     *                interest.
     * @return the stale counter of <code>e</code>.
     * @throws NoSuchFieldException
     *                 if the name of the stale counter variable has changed and
     *                 has been forgotten here.
     */
    public static <T extends KademliaOverlayID> int getStaleCounter(
	    RoutingTableEntry<T> e) throws NoSuchFieldException {
	return (Integer) PrivateAccessor.getField(e, "staleCounter");
    }
}
