package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.measurement;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.measurement.AvgAccumulator;

/**
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 * 
 */
public class AvgAccumulatorTest {

    private AvgAccumulator a;

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
	a = new AvgAccumulator();
    }

    /**
     * The average of zero samples is zero.
     */
    @Test
    public void testZeroSamples() {
	assertEquals("The average of zero samples is zero.", 0d, a.getAverage());
    }

    /**
     * The average of one sample is the sample itself.
     */
    @Test
    public void testOneSample() {
	a.addToTotal(948);
	assertEquals("The average of one sample is the sample itself.", 948d, a
		.getAverage());
    }

    /**
     * Tests whether the average is computed correctly.
     */
    @Test
    public void testAverage() {
	a.addToTotal(39);
	a.addToTotal(4875);
	a.addToTotal(39584587);
	a.addToTotal(1);
	a.addToTotal(0);
	assertEquals("The average should be 7917900.4", 7917900.4d, a
		.getAverage());
    }

}
