package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.measurement;

import static org.junit.Assert.*;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;

import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.measurement.FileAnalyzer;

/**
 * Test cases for FileAnalyzer.
 * 
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 */
public class FileAnalyzerTest {

    private static final String TEST_FILE = "test/kademlia2/measurement/fileAnalyzerTest.txt";

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
	File testFile = new File(TEST_FILE);
	testFile.delete();
    }

    private String getFileContents() throws Exception {
	BufferedReader in = new BufferedReader(new FileReader(TEST_FILE));
	StringBuilder actual = new StringBuilder();
	String tmp;
	while ((tmp = in.readLine()) != null) {
	    actual.append(tmp);
	    actual.append('\n');
	}
	return actual.substring(0, actual.length() - 1);
    }

    /**
     * Basic test for FileAnalyzer.
     */
    @Test
    public void testFileAnalyzer() throws Exception {
	final String expected = "This is a test for FileAnalyzer.\nSecond line.";
	FileAnalyzer testObj = new FileAnalyzer();
	testObj.setOutputFile(TEST_FILE);
	testObj.start();
	testObj.appendToFile("This is a test for FileAnalyzer.");
	testObj.appendNewLine();
	testObj.appendToFile("Second line.");
	testObj.stop(null);
	assertEquals("Output should be as expected.", expected,
		getFileContents());
    }
}
