package de.tud.kom.p2psim.impl.overlay.dht.kademlia2.measurement.file;

import static org.junit.Assert.*;

import org.apache.commons.math.util.MathUtils;
import org.junit.Test;

import de.tud.kom.p2psim.impl.overlay.dht.kademlia2.measurement.file.ConfidenceCalculator;

/**
 * Test case for ConfidenceCalculator.
 * 
 * @author Tobias Lauinger <tl1003@rbg.informatik.tu-darmstadt.de>
 */
public class ConfidenceCalculatorTest {

    /**
     * Tests the ConfidenceCalculator with sample data from Jain, R.; The Art of
     * Computer Systems Performance Analysis, Wiley &amp; Sons, New York 1991,
     * p. 208.
     */
    @Test
    public void testConfidenceCalculator() {
	/*
	 * Some expected values differ from the data in [Jain] as we calculate
	 * with greater precision.
	 */
	double[] actual = ConfidenceCalculator.calc(new double[] { 1.5, 2.6,
		-1.8, 1.3, -0.5, 1.7, 2.4 }, 0.01);
	assertEquals("Expected mean 1.03", 1.03, MathUtils.round(actual[0], 2));
	assertEquals("Expected standard deviation 1.6", 1.6, MathUtils.round(
		actual[1], 2));
	assertEquals("Expected delta 2.25", 2.25, MathUtils.round(actual[2], 2));
	assertEquals("Expected lower bound -1.22", -1.22, MathUtils.round(
		actual[3], 2));
	assertEquals("Expected upper bound 3.28", 3.28, MathUtils.round(
		actual[4], 2));
    }
}
